/* Application.c generated by valac 0.56.2, the Vala compiler
 * generated from Application.vala, do not modify */

/*-
 * Copyright (c) 2013-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 *              Cody Garver <cody@elementaryos.org>
 *              Artem Anufrij <artem.anufrij@live.de>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <clutter/clutter.h>
#include <clutter-gtk/clutter-gtk.h>
#include <gst/gst.h>

#define AUDIENCE_SCHEMA "io.elementary.videos"
#define AUDIENCE_APP_ACTION_PREFIX "app."
#define AUDIENCE_APP_ACTION_PLAY_PAUSE "action-play-pause"
#define GETTEXT_PACKAGE "io.elementary.videos"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AUDIENCE_TYPE_APP (audience_app_get_type ())
#define AUDIENCE_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_APP, AudienceApp))
#define AUDIENCE_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_APP, AudienceAppClass))
#define AUDIENCE_IS_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_APP))
#define AUDIENCE_IS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_APP))
#define AUDIENCE_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_APP, AudienceAppClass))

typedef struct _AudienceApp AudienceApp;
typedef struct _AudienceAppClass AudienceAppClass;
typedef struct _AudienceAppPrivate AudienceAppPrivate;

#define AUDIENCE_TYPE_WINDOW (audience_window_get_type ())
#define AUDIENCE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindow))
#define AUDIENCE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))
#define AUDIENCE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))

typedef struct _AudienceWindow AudienceWindow;
typedef struct _AudienceWindowClass AudienceWindowClass;
enum  {
	AUDIENCE_APP_0_PROPERTY,
	AUDIENCE_APP_NUM_PROPERTIES
};
static GParamSpec* audience_app_properties[AUDIENCE_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _AudienceApp {
	GtkApplication parent_instance;
	AudienceAppPrivate * priv;
	AudienceWindow* mainwindow;
	GVolumeMonitor* monitor;
};

struct _AudienceAppClass {
	GtkApplicationClass parent_class;
};

VALA_EXTERN GSettings* audience_settings;
GSettings* audience_settings = NULL;
static gpointer audience_app_parent_class = NULL;
static AudienceApp* audience_app_app;
static AudienceApp* audience_app_app = NULL;

VALA_EXTERN GType audience_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceApp, g_object_unref)
VALA_EXTERN GType audience_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWindow, g_object_unref)
static void audience_app_action_play_pause (AudienceApp* self);
static void _audience_app_action_play_pause_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN AudienceApp* audience_app_new (void);
VALA_EXTERN AudienceApp* audience_app_construct (GType object_type);
VALA_EXTERN AudienceApp* audience_app_get_instance (void);
static void audience_app_real_activate (GApplication* base);
VALA_EXTERN gchar* audience_app_get_cache_directory (AudienceApp* self);
VALA_EXTERN AudienceWindow* audience_window_new (void);
VALA_EXTERN AudienceWindow* audience_window_construct (GType object_type);
static void audience_app_real_open (GApplication* base,
                             GFile** files,
                             gint files_length1,
                             const gchar* hint);
VALA_EXTERN void audience_window_open_files (AudienceWindow* self,
                                 GFile** files,
                                 gint files_length1,
                                 gboolean clear_playlist_items,
                                 gboolean force_play);
static GVariant* _variant_new1 (gboolean value);
static GVariant* _variant_new2 (gboolean value);
static GObject * audience_app_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void audience_app_finalize (GObject * obj);
static GType audience_app_get_type_once (void);
static void _vala_main (gchar** args,
                 gint args_length1);

static const GActionEntry AUDIENCE_APP_ACTION_ENTRIES[1] = {{AUDIENCE_APP_ACTION_PLAY_PAUSE, _audience_app_action_play_pause_gsimple_action_activate_callback, NULL, "false"}};

static void
_audience_app_action_play_pause_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 31 "../src/Application.vala"
	audience_app_action_play_pause ((AudienceApp*) self);
#line 147 "Application.c"
}

AudienceApp*
audience_app_construct (GType object_type)
{
	AudienceApp * self = NULL;
	GtkSettings* _tmp0_;
	GApplicationFlags _tmp1_;
	GApplicationFlags _tmp2_;
	GSettings* _tmp3_;
#line 46 "../src/Application.vala"
	self = (AudienceApp*) g_object_new (object_type, NULL);
#line 47 "../src/Application.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 47 "../src/Application.vala"
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", TRUE, NULL);
#line 48 "../src/Application.vala"
	_tmp1_ = g_application_get_flags ((GApplication*) self);
#line 48 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 48 "../src/Application.vala"
	g_application_set_flags ((GApplication*) self, _tmp2_ | G_APPLICATION_HANDLES_OPEN);
#line 50 "../src/Application.vala"
	_tmp3_ = g_settings_new (AUDIENCE_SCHEMA);
#line 50 "../src/Application.vala"
	_g_object_unref0 (audience_settings);
#line 50 "../src/Application.vala"
	audience_settings = _tmp3_;
#line 46 "../src/Application.vala"
	return self;
#line 178 "Application.c"
}

AudienceApp*
audience_app_new (void)
{
#line 46 "../src/Application.vala"
	return audience_app_construct (AUDIENCE_TYPE_APP);
#line 186 "Application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 194 "Application.c"
}

AudienceApp*
audience_app_get_instance (void)
{
	AudienceApp* _tmp0_;
	AudienceApp* _tmp2_;
	AudienceApp* _tmp3_;
	AudienceApp* result;
#line 55 "../src/Application.vala"
	_tmp0_ = audience_app_app;
#line 55 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 208 "Application.c"
		AudienceApp* _tmp1_;
#line 56 "../src/Application.vala"
		_tmp1_ = audience_app_new ();
#line 56 "../src/Application.vala"
		_g_object_unref0 (audience_app_app);
#line 56 "../src/Application.vala"
		audience_app_app = _tmp1_;
#line 216 "Application.c"
	}
#line 57 "../src/Application.vala"
	_tmp2_ = audience_app_app;
#line 57 "../src/Application.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 57 "../src/Application.vala"
	result = _tmp3_;
#line 57 "../src/Application.vala"
	return result;
#line 226 "Application.c"
}

static void
audience_app_real_activate (GApplication* base)
{
	AudienceApp * self;
	AudienceWindow* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 60 "../src/Application.vala"
	self = (AudienceApp*) base;
#line 61 "../src/Application.vala"
	_tmp0_ = self->mainwindow;
#line 61 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 241 "Application.c"
		GSettings* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp4_;
		AudienceWindow* _tmp15_;
		AudienceWindow* _tmp16_;
		AudienceWindow* _tmp17_;
#line 62 "../src/Application.vala"
		g_action_map_add_action_entries ((GActionMap*) self, AUDIENCE_APP_ACTION_ENTRIES, (gint) G_N_ELEMENTS (AUDIENCE_APP_ACTION_ENTRIES), self);
#line 64 "../src/Application.vala"
		_tmp1_ = audience_settings;
#line 64 "../src/Application.vala"
		_tmp2_ = g_settings_get_string (_tmp1_, "last-folder");
#line 64 "../src/Application.vala"
		_tmp3_ = _tmp2_;
#line 64 "../src/Application.vala"
		_tmp4_ = g_strcmp0 (_tmp3_, "-1") == 0;
#line 64 "../src/Application.vala"
		_g_free0 (_tmp3_);
#line 64 "../src/Application.vala"
		if (_tmp4_) {
#line 263 "Application.c"
			GSettings* _tmp5_;
			const gchar* _tmp6_;
#line 65 "../src/Application.vala"
			_tmp5_ = audience_settings;
#line 65 "../src/Application.vala"
			_tmp6_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
#line 65 "../src/Application.vala"
			g_settings_set_string (_tmp5_, "last-folder", _tmp6_);
#line 272 "Application.c"
		}
		{
			GFile* cache = NULL;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
#line 69 "../src/Application.vala"
			_tmp7_ = audience_app_get_cache_directory (self);
#line 69 "../src/Application.vala"
			_tmp8_ = _tmp7_;
#line 69 "../src/Application.vala"
			_tmp9_ = g_file_new_for_path (_tmp8_);
#line 69 "../src/Application.vala"
			_tmp10_ = _tmp9_;
#line 69 "../src/Application.vala"
			_g_free0 (_tmp8_);
#line 69 "../src/Application.vala"
			cache = _tmp10_;
#line 70 "../src/Application.vala"
			_tmp11_ = cache;
#line 70 "../src/Application.vala"
			if (!g_file_query_exists (_tmp11_, NULL)) {
#line 297 "Application.c"
				GFile* _tmp12_;
#line 71 "../src/Application.vala"
				_tmp12_ = cache;
#line 71 "../src/Application.vala"
				g_file_make_directory (_tmp12_, NULL, &_inner_error0_);
#line 71 "../src/Application.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/Application.vala"
					_g_object_unref0 (cache);
#line 307 "Application.c"
					goto __catch0_g_error;
				}
			}
#line 68 "../src/Application.vala"
			_g_object_unref0 (cache);
#line 313 "Application.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 68 "../src/Application.vala"
			e = _inner_error0_;
#line 68 "../src/Application.vala"
			_inner_error0_ = NULL;
#line 74 "../src/Application.vala"
			_tmp13_ = e;
#line 74 "../src/Application.vala"
			_tmp14_ = _tmp13_->message;
#line 74 "../src/Application.vala"
			g_warning ("Application.vala:74: %s", _tmp14_);
#line 68 "../src/Application.vala"
			_g_error_free0 (e);
#line 333 "Application.c"
		}
		__finally0:
#line 68 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/Application.vala"
			g_clear_error (&_inner_error0_);
#line 68 "../src/Application.vala"
			return;
#line 344 "Application.c"
		}
#line 77 "../src/Application.vala"
		_tmp15_ = audience_window_new ();
#line 77 "../src/Application.vala"
		g_object_ref_sink (_tmp15_);
#line 77 "../src/Application.vala"
		_g_object_unref0 (self->mainwindow);
#line 77 "../src/Application.vala"
		self->mainwindow = _tmp15_;
#line 78 "../src/Application.vala"
		_tmp16_ = self->mainwindow;
#line 78 "../src/Application.vala"
		gtk_window_set_application ((GtkWindow*) _tmp16_, (GtkApplication*) self);
#line 79 "../src/Application.vala"
		_tmp17_ = self->mainwindow;
#line 79 "../src/Application.vala"
		gtk_window_set_title ((GtkWindow*) _tmp17_, _ ("Videos"));
#line 362 "Application.c"
	}
}

gchar*
audience_app_get_cache_directory (AudienceApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 83 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/Application.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 84 "../src/Application.vala"
	_tmp1_ = g_application_get_application_id ((GApplication*) self);
#line 84 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/Application.vala"
	_tmp3_ = g_build_filename (_tmp0_, _tmp2_, NULL);
#line 84 "../src/Application.vala"
	result = _tmp3_;
#line 84 "../src/Application.vala"
	return result;
#line 388 "Application.c"
}

static void
audience_app_real_open (GApplication* base,
                        GFile** files,
                        gint files_length1,
                        const gchar* hint)
{
	AudienceApp * self;
	AudienceWindow* _tmp0_;
#line 88 "../src/Application.vala"
	self = (AudienceApp*) base;
#line 88 "../src/Application.vala"
	g_return_if_fail (hint != NULL);
#line 89 "../src/Application.vala"
	g_application_activate ((GApplication*) self);
#line 90 "../src/Application.vala"
	_tmp0_ = self->mainwindow;
#line 90 "../src/Application.vala"
	audience_window_open_files (_tmp0_, files, (gint) files_length1, TRUE, TRUE);
#line 409 "Application.c"
}

static GVariant*
_variant_new1 (gboolean value)
{
#line 96 "../src/Application.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 417 "Application.c"
}

static GVariant*
_variant_new2 (gboolean value)
{
#line 98 "../src/Application.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 425 "Application.c"
}

static void
audience_app_action_play_pause (AudienceApp* self)
{
	GAction* play_pause_action = NULL;
	GAction* _tmp0_;
	GAction* _tmp1_;
	GAction* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gboolean _tmp5_;
#line 93 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Application.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 94 "../src/Application.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 94 "../src/Application.vala"
	play_pause_action = _tmp1_;
#line 95 "../src/Application.vala"
	_tmp2_ = play_pause_action;
#line 95 "../src/Application.vala"
	_tmp3_ = g_action_get_state (_tmp2_);
#line 95 "../src/Application.vala"
	_tmp4_ = _tmp3_;
#line 95 "../src/Application.vala"
	_tmp5_ = g_variant_get_boolean (_tmp4_);
#line 95 "../src/Application.vala"
	_g_variant_unref0 (_tmp4_);
#line 95 "../src/Application.vala"
	if (_tmp5_) {
#line 458 "Application.c"
		GAction* _tmp6_;
		GVariant* _tmp7_;
#line 96 "../src/Application.vala"
		_tmp6_ = play_pause_action;
#line 96 "../src/Application.vala"
		_tmp7_ = _variant_new1 (FALSE);
#line 96 "../src/Application.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_simple_action_get_type (), GSimpleAction), _tmp7_);
#line 96 "../src/Application.vala"
		_g_variant_unref0 (_tmp7_);
#line 469 "Application.c"
	} else {
		GAction* _tmp8_;
		GVariant* _tmp9_;
#line 98 "../src/Application.vala"
		_tmp8_ = play_pause_action;
#line 98 "../src/Application.vala"
		_tmp9_ = _variant_new2 (TRUE);
#line 98 "../src/Application.vala"
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_simple_action_get_type (), GSimpleAction), _tmp9_);
#line 98 "../src/Application.vala"
		_g_variant_unref0 (_tmp9_);
#line 481 "Application.c"
	}
#line 93 "../src/Application.vala"
	_g_object_unref0 (play_pause_action);
#line 485 "Application.c"
}

static GObject *
audience_app_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudienceApp * self;
#line 38 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (audience_app_parent_class);
#line 38 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_APP, AudienceApp);
#line 39 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 40 "../src/Application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 41 "../src/Application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 42 "../src/Application.vala"
	textdomain (GETTEXT_PACKAGE);
#line 43 "../src/Application.vala"
	g_application_set_application_id ((GApplication*) self, "io.elementary.videos");
#line 38 "../src/Application.vala"
	return obj;
#line 514 "Application.c"
}

static void
audience_app_class_init (AudienceAppClass * klass,
                         gpointer klass_data)
{
#line 27 "../src/Application.vala"
	audience_app_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) audience_app_real_activate;
#line 27 "../src/Application.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) audience_app_real_open;
#line 27 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = audience_app_constructor;
#line 27 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = audience_app_finalize;
#line 531 "Application.c"
}

static void
audience_app_instance_init (AudienceApp * self,
                            gpointer klass)
{
}

static void
audience_app_finalize (GObject * obj)
{
	AudienceApp * self;
#line 27 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_APP, AudienceApp);
#line 35 "../src/Application.vala"
	_g_object_unref0 (self->mainwindow);
#line 36 "../src/Application.vala"
	_g_object_unref0 (self->monitor);
#line 27 "../src/Application.vala"
	G_OBJECT_CLASS (audience_app_parent_class)->finalize (obj);
#line 552 "Application.c"
}

static GType
audience_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AudienceAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceApp), 0, (GInstanceInitFunc) audience_app_instance_init, NULL };
	GType audience_app_type_id;
	audience_app_type_id = g_type_register_static (gtk_application_get_type (), "AudienceApp", &g_define_type_info, 0);
	return audience_app_type_id;
}

GType
audience_app_get_type (void)
{
	static volatile gsize audience_app_type_id__once = 0;
	if (g_once_init_enter (&audience_app_type_id__once)) {
		GType audience_app_type_id;
		audience_app_type_id = audience_app_get_type_once ();
		g_once_init_leave (&audience_app_type_id__once, audience_app_type_id);
	}
	return audience_app_type_id__once;
}

static void
_vala_main (gchar** args,
            gint args_length1)
{
	ClutterInitError err = 0;
	ClutterInitError _tmp0_;
	AudienceApp* app = NULL;
	AudienceApp* _tmp2_;
#line 105 "../src/Application.vala"
	XInitThreads ();
#line 107 "../src/Application.vala"
	_tmp0_ = gtk_clutter_init ((gint*) (&args_length1), &args);
#line 107 "../src/Application.vala"
	err = _tmp0_;
#line 108 "../src/Application.vala"
	if (err != CLUTTER_INIT_SUCCESS) {
#line 592 "Application.c"
		GEnumValue* _tmp1_;
#line 109 "../src/Application.vala"
		_tmp1_ = g_enum_get_value (g_type_class_ref (clutter_init_error_get_type ()), err);
#line 109 "../src/Application.vala"
		g_error ("Application.vala:109: Could not initialize clutter! %s", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 598 "Application.c"
	}
#line 112 "../src/Application.vala"
	gst_init ((gint*) (&args_length1), &args);
#line 114 "../src/Application.vala"
	_tmp2_ = audience_app_get_instance ();
#line 114 "../src/Application.vala"
	app = _tmp2_;
#line 116 "../src/Application.vala"
	g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 104 "../src/Application.vala"
	_g_object_unref0 (app);
#line 610 "Application.c"
}

int
main (int argc,
      char ** argv)
{
#line 104 "../src/Application.vala"
	_vala_main (argv, argc);
#line 104 "../src/Application.vala"
	return 0;
#line 621 "Application.c"
}

