/* Window.c generated by valac 0.56.2, the Vala compiler
 * generated from Window.vala, do not modify */

/*-
 * Copyright (c) 2013-2019 elementary Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 *              Cody Garver <cody@elementaryos.org>
 *              Artem Anufrij <artem.anufrij@live.de>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define AUDIENCE_WINDOW_NAVIGATION_BUTTON_WELCOMESCREEN N_ ("Back")
#define AUDIENCE_WINDOW_NAVIGATION_BUTTON_LIBRARY N_ ("Library")
#define AUDIENCE_WINDOW_NAVIGATION_BUTTON_EPISODES N_ ("Episodes")
#define AUDIENCE_WINDOW_ACTION_GROUP_PREFIX "win"
#define AUDIENCE_WINDOW_ACTION_PREFIX AUDIENCE_WINDOW_ACTION_GROUP_PREFIX "."
#define AUDIENCE_WINDOW_ACTION_BACK "back"
#define AUDIENCE_WINDOW_ACTION_FULLSCREEN "action-fullscreen"
#define AUDIENCE_WINDOW_ACTION_OPEN_FILE "action-open-file"
#define AUDIENCE_WINDOW_ACTION_QUIT "action-quit"
#define AUDIENCE_WINDOW_ACTION_SEARCH "action-search"
#define AUDIENCE_WINDOW_ACTION_UNDO "action-undo"
#define AUDIENCE_APP_ACTION_PLAY_PAUSE "action-play-pause"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AUDIENCE_TYPE_WINDOW (audience_window_get_type ())
#define AUDIENCE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindow))
#define AUDIENCE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))
#define AUDIENCE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))

typedef struct _AudienceWindow AudienceWindow;
typedef struct _AudienceWindowClass AudienceWindowClass;
typedef struct _AudienceWindowPrivate AudienceWindowPrivate;

#define AUDIENCE_TYPE_EPISODES_PAGE (audience_episodes_page_get_type ())
#define AUDIENCE_EPISODES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPage))
#define AUDIENCE_EPISODES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPageClass))
#define AUDIENCE_IS_EPISODES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_EPISODES_PAGE))
#define AUDIENCE_IS_EPISODES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_EPISODES_PAGE))
#define AUDIENCE_EPISODES_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_EPISODES_PAGE, AudienceEpisodesPageClass))

typedef struct _AudienceEpisodesPage AudienceEpisodesPage;
typedef struct _AudienceEpisodesPageClass AudienceEpisodesPageClass;

#define AUDIENCE_TYPE_LIBRARY_PAGE (audience_library_page_get_type ())
#define AUDIENCE_LIBRARY_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPage))
#define AUDIENCE_LIBRARY_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPageClass))
#define AUDIENCE_IS_LIBRARY_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_LIBRARY_PAGE))
#define AUDIENCE_IS_LIBRARY_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_LIBRARY_PAGE))
#define AUDIENCE_LIBRARY_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_LIBRARY_PAGE, AudienceLibraryPageClass))

typedef struct _AudienceLibraryPage AudienceLibraryPage;
typedef struct _AudienceLibraryPageClass AudienceLibraryPageClass;

#define AUDIENCE_TYPE_WELCOME_PAGE (audience_welcome_page_get_type ())
#define AUDIENCE_WELCOME_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePage))
#define AUDIENCE_WELCOME_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePageClass))
#define AUDIENCE_IS_WELCOME_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WELCOME_PAGE))
#define AUDIENCE_IS_WELCOME_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WELCOME_PAGE))
#define AUDIENCE_WELCOME_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WELCOME_PAGE, AudienceWelcomePageClass))

typedef struct _AudienceWelcomePage AudienceWelcomePage;
typedef struct _AudienceWelcomePageClass AudienceWelcomePageClass;

#define AUDIENCE_TYPE_PLAYER_PAGE (audience_player_page_get_type ())
#define AUDIENCE_PLAYER_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPage))
#define AUDIENCE_PLAYER_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPageClass))
#define AUDIENCE_IS_PLAYER_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_PLAYER_PAGE))
#define AUDIENCE_IS_PLAYER_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_PLAYER_PAGE))
#define AUDIENCE_PLAYER_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_PLAYER_PAGE, AudiencePlayerPageClass))

typedef struct _AudiencePlayerPage AudiencePlayerPage;
typedef struct _AudiencePlayerPageClass AudiencePlayerPageClass;
enum  {
	AUDIENCE_WINDOW_0_PROPERTY,
	AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY,
	AUDIENCE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* audience_window_properties[AUDIENCE_WINDOW_NUM_PROPERTIES];
typedef enum  {
	AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME,
	AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY,
	AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES
} AudienceWindowNavigationPage;

#define AUDIENCE_WINDOW_TYPE_NAVIGATION_PAGE (audience_window_navigation_page_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER (audience_services_library_manager_get_type ())
#define AUDIENCE_SERVICES_LIBRARY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManager))
#define AUDIENCE_SERVICES_LIBRARY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManagerClass))
#define AUDIENCE_SERVICES_IS_LIBRARY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER))
#define AUDIENCE_SERVICES_IS_LIBRARY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER))
#define AUDIENCE_SERVICES_LIBRARY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_SERVICES_TYPE_LIBRARY_MANAGER, AudienceServicesLibraryManagerClass))

typedef struct _AudienceServicesLibraryManager AudienceServicesLibraryManager;
typedef struct _AudienceServicesLibraryManagerClass AudienceServicesLibraryManagerClass;
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef void (*AudienceFuncOverDir) (GFile* file_under_dir, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))

#define AUDIENCE_TYPE_DISK_MANAGER (audience_disk_manager_get_type ())
#define AUDIENCE_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManager))
#define AUDIENCE_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))
#define AUDIENCE_IS_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_IS_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_DISK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))

typedef struct _AudienceDiskManager AudienceDiskManager;
typedef struct _AudienceDiskManagerClass AudienceDiskManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _AudienceWindowReadFirstDiskData AudienceWindowReadFirstDiskData;

#define AUDIENCE_WIDGETS_TYPE_PLAYLIST (audience_widgets_playlist_get_type ())
#define AUDIENCE_WIDGETS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_WIDGETS_TYPE_PLAYLIST, AudienceWidgetsPlaylist))
#define AUDIENCE_WIDGETS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_WIDGETS_TYPE_PLAYLIST, AudienceWidgetsPlaylistClass))
#define AUDIENCE_WIDGETS_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_WIDGETS_TYPE_PLAYLIST))
#define AUDIENCE_WIDGETS_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_WIDGETS_TYPE_PLAYLIST))
#define AUDIENCE_WIDGETS_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_WIDGETS_TYPE_PLAYLIST, AudienceWidgetsPlaylistClass))

typedef struct _AudienceWidgetsPlaylist AudienceWidgetsPlaylist;
typedef struct _AudienceWidgetsPlaylistClass AudienceWidgetsPlaylistClass;
typedef struct _Block3Data Block3Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define AUDIENCE_TYPE_LIBRARY_ITEM (audience_library_item_get_type ())
#define AUDIENCE_LIBRARY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_LIBRARY_ITEM, AudienceLibraryItem))
#define AUDIENCE_LIBRARY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_LIBRARY_ITEM, AudienceLibraryItemClass))
#define AUDIENCE_IS_LIBRARY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_LIBRARY_ITEM))
#define AUDIENCE_IS_LIBRARY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_LIBRARY_ITEM))
#define AUDIENCE_LIBRARY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_LIBRARY_ITEM, AudienceLibraryItemClass))

typedef struct _AudienceLibraryItem AudienceLibraryItem;
typedef struct _AudienceLibraryItemClass AudienceLibraryItemClass;

#define AUDIENCE_OBJECTS_TYPE_VIDEO (audience_objects_video_get_type ())
#define AUDIENCE_OBJECTS_VIDEO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_OBJECTS_TYPE_VIDEO, AudienceObjectsVideo))
#define AUDIENCE_OBJECTS_VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_OBJECTS_TYPE_VIDEO, AudienceObjectsVideoClass))
#define AUDIENCE_OBJECTS_IS_VIDEO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_OBJECTS_TYPE_VIDEO))
#define AUDIENCE_OBJECTS_IS_VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_OBJECTS_TYPE_VIDEO))
#define AUDIENCE_OBJECTS_VIDEO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_OBJECTS_TYPE_VIDEO, AudienceObjectsVideoClass))

typedef struct _AudienceObjectsVideo AudienceObjectsVideo;
typedef struct _AudienceObjectsVideoClass AudienceObjectsVideoClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
enum  {
	AUDIENCE_WINDOW_MEDIA_VOLUMES_CHANGED_SIGNAL,
	AUDIENCE_WINDOW_NUM_SIGNALS
};
static guint audience_window_signals[AUDIENCE_WINDOW_NUM_SIGNALS] = {0};

struct _AudienceWindow {
	GtkApplicationWindow parent_instance;
	AudienceWindowPrivate * priv;
};

struct _AudienceWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _AudienceWindowPrivate {
	HdyDeck* deck;
	GraniteWidgetsToast* app_notification;
	GraniteModeSwitch* autoqueue_next;
	AudienceEpisodesPage* episodes_page;
	GtkHeaderBar* header;
	AudienceLibraryPage* library_page;
	GtkButton* navigation_button;
	GtkSearchEntry* search_entry;
	AudienceWelcomePage* welcome_page;
	AudiencePlayerPage* _player_page;
};

struct _Block1Data {
	int _ref_count_;
	AudienceWindow* self;
	gchar** videos;
	gint videos_length1;
	gint _videos_size_;
};

struct _Block2Data {
	int _ref_count_;
	Block1Data * _data1_;
	GFile* file;
};

struct _AudienceWindowReadFirstDiskData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AudienceWindow* self;
	AudienceDiskManager* disk_manager;
	AudienceDiskManager* _tmp0_;
	AudienceDiskManager* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GVolume* volume;
	AudienceDiskManager* _tmp7_;
	GeeTreeSet* _tmp8_;
	GeeTreeSet* _tmp9_;
	gpointer _tmp10_;
	GVolume* _tmp11_;
	gboolean _tmp12_;
	GVolume* _tmp13_;
	GVolume* _tmp14_;
	GMount* _tmp15_;
	GMount* _tmp16_;
	GVolume* _tmp17_;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GFile* root;
	GVolume* _tmp20_;
	GMount* _tmp21_;
	GMount* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	AudienceWindow* self;
	GAction* play_pause_action;
};

static gint AudienceWindow_private_offset;
static gpointer audience_window_parent_class = NULL;
static GeeMultiMap* audience_window_action_accelerators;
static GeeMultiMap* audience_window_action_accelerators = NULL;
VALA_EXTERN GSettings* audience_settings;

VALA_EXTERN GType audience_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWindow, g_object_unref)
VALA_EXTERN GType audience_episodes_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceEpisodesPage, g_object_unref)
VALA_EXTERN GType audience_library_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceLibraryPage, g_object_unref)
VALA_EXTERN GType audience_welcome_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWelcomePage, g_object_unref)
VALA_EXTERN GType audience_player_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudiencePlayerPage, g_object_unref)
VALA_EXTERN GType audience_window_navigation_page_get_type (void) G_GNUC_CONST ;
static void audience_window_action_back (AudienceWindow* self);
static void _audience_window_action_back_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void audience_window_action_fullscreen (AudienceWindow* self);
static void _audience_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void audience_window_action_open_file (AudienceWindow* self);
static void _audience_window_action_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void audience_window_action_quit (AudienceWindow* self);
static void _audience_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void audience_window_action_search (AudienceWindow* self);
static void _audience_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void audience_window_action_undo (AudienceWindow* self);
static void _audience_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
VALA_EXTERN AudiencePlayerPage* audience_window_get_player_page (AudienceWindow* self);
VALA_EXTERN gboolean audience_player_page_get_fullscreened (AudiencePlayerPage* self);
VALA_EXTERN void audience_window_run_open_file (AudienceWindow* self,
                                    gboolean clear_playlist,
                                    gboolean force_play);
VALA_EXTERN gboolean audience_is_sandboxed (void);
VALA_EXTERN GType audience_services_library_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceServicesLibraryManager, g_object_unref)
VALA_EXTERN AudienceServicesLibraryManager* audience_services_library_manager_get_instance (void);
VALA_EXTERN void audience_services_library_manager_undo_delete_item (AudienceServicesLibraryManager* self);
VALA_EXTERN gboolean audience_window_match_keycode (AudienceWindow* self,
                                        guint keyval,
                                        guint code);
static gboolean audience_window_real_key_press_event (GtkWidget* base,
                                               GdkEventKey* e);
VALA_EXTERN void audience_player_page_next_audio (AudiencePlayerPage* self);
VALA_EXTERN void audience_player_page_next_text (AudiencePlayerPage* self);
VALA_EXTERN void audience_player_page_seek_jump_seconds (AudiencePlayerPage* self,
                                             gint seconds);
VALA_EXTERN void audience_window_resume_last_videos (AudienceWindow* self);
VALA_EXTERN void audience_window_show_library (AudienceWindow* self);
VALA_EXTERN void audience_window_open_files (AudienceWindow* self,
                                 GFile** files,
                                 gint files_length1,
                                 gboolean clear_playlist_items,
                                 gboolean force_play);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
VALA_EXTERN void audience_window_clear_playlist (AudienceWindow* self,
                                     gboolean should_stop);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN void audience_recurse_over_dir (GFile* file_to_process,
                                AudienceFuncOverDir func,
                                gpointer func_target);
static void _____lambda25_ (Block2Data* _data2_,
                     GFile* file_ret);
VALA_EXTERN void audience_player_page_append_to_playlist (AudiencePlayerPage* self,
                                              GFile* file);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void ______lambda25__audience_func_over_dir (GFile* file_under_dir,
                                             gpointer self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN AudienceWindowNavigationPage audience_library_page_prepare_to_play (AudienceLibraryPage* self,
                                                                    const gchar* file);
VALA_EXTERN void audience_window_play_file (AudienceWindow* self,
                                const gchar* uri,
                                AudienceWindowNavigationPage origin,
                                gboolean from_beginning);
VALA_EXTERN void audience_window_run_open_dvd (AudienceWindow* self);
static void audience_window_read_first_disk (AudienceWindow* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void audience_window_read_first_disk_finish (AudienceWindow* self,
                                             GAsyncResult* _res_);
VALA_EXTERN void audience_window_add_to_playlist (AudienceWindow* self,
                                      const gchar* uri,
                                      gboolean preserve_playlist);
static void _vala_array_add3 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
VALA_EXTERN gboolean audience_window_is_privacy_mode_enabled (AudienceWindow* self);
static void audience_window_read_first_disk_data_free (gpointer _data);
static gboolean audience_window_read_first_disk_co (AudienceWindowReadFirstDiskData* _data_);
VALA_EXTERN GType audience_disk_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceDiskManager, g_object_unref)
VALA_EXTERN AudienceDiskManager* audience_disk_manager_get_default (void);
VALA_EXTERN GeeTreeSet* audience_disk_manager_get_volumes (AudienceDiskManager* self);
static void audience_window_read_first_disk_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void audience_window_on_player_ended (AudienceWindow* self);
VALA_EXTERN void audience_player_page_play_file (AudiencePlayerPage* self,
                                     const gchar* uri,
                                     gboolean from_beginning);
VALA_EXTERN GType audience_widgets_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWidgetsPlaylist, g_object_unref)
VALA_EXTERN AudienceWidgetsPlaylist* audience_player_page_get_playlist_widget (AudiencePlayerPage* self);
VALA_EXTERN void audience_widgets_playlist_clear_items (AudienceWidgetsPlaylist* self,
                                            gboolean should_stop);
VALA_EXTERN void audience_window_append_to_playlist (AudienceWindow* self,
                                         GFile* file);
static void audience_window_update_navigation (AudienceWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gdouble audience_player_page_get_progress (AudiencePlayerPage* self);
static GVariant* _variant_new3 (gboolean value);
static gboolean ___lambda88_ (Block3Data* _data3_);
static GVariant* _variant_new4 (gboolean value);
static gboolean ____lambda88__gsource_func (gpointer self);
VALA_EXTERN void audience_window_hide_mouse_cursor (AudienceWindow* self);
VALA_EXTERN void audience_window_show_mouse_cursor (AudienceWindow* self);
VALA_EXTERN gboolean audience_window_autoqueue_next_active (AudienceWindow* self);
VALA_EXTERN AudienceWindow* audience_window_new (void);
VALA_EXTERN AudienceWindow* audience_window_construct (GType object_type);
static void audience_window_set_player_page (AudienceWindow* self,
                                      AudiencePlayerPage* value);
static GObject * audience_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _audience_window___lambda89_ (AudienceWindow* self);
static void __audience_window___lambda89__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _audience_window___lambda90_ (AudienceWindow* self);
VALA_EXTERN void audience_episodes_page_filter (AudienceEpisodesPage* self,
                                    const gchar* text);
VALA_EXTERN void audience_library_page_filter (AudienceLibraryPage* self,
                                   const gchar* text);
static void __audience_window___lambda90__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                    gpointer self);
VALA_EXTERN AudienceLibraryPage* audience_library_page_get_instance (void);
static void _audience_window___lambda91_ (AudienceWindow* self);
VALA_EXTERN gboolean audience_library_page_has_child (AudienceLibraryPage* self);
VALA_EXTERN const gchar* audience_library_page_get_last_filter (AudienceLibraryPage* self);
VALA_EXTERN void audience_library_page_set_last_filter (AudienceLibraryPage* self,
                                            const gchar* value);
static void __audience_window___lambda91__gtk_widget_map (GtkWidget* _sender,
                                                   gpointer self);
VALA_EXTERN GType audience_library_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceLibraryItem, g_object_unref)
static void _audience_window___lambda92_ (AudienceWindow* self,
                                   AudienceLibraryItem* item,
                                   gboolean setup_only);
VALA_EXTERN GType audience_objects_video_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceObjectsVideo, g_object_unref)
VALA_EXTERN void audience_episodes_page_set_episodes_items (AudienceEpisodesPage* self,
                                                GeeArrayList* episodes);
VALA_EXTERN GeeArrayList* audience_library_item_get_episodes (AudienceLibraryItem* self);
VALA_EXTERN GtkImage* audience_episodes_page_get_poster (AudienceEpisodesPage* self);
VALA_EXTERN GtkImage* audience_library_item_get_poster (AudienceLibraryItem* self);
VALA_EXTERN gchar* audience_library_item_get_title (AudienceLibraryItem* self);
static void __audience_window___lambda92__audience_library_page_show_episodes (AudienceLibraryPage* _sender,
                                                                        AudienceLibraryItem* item,
                                                                        gboolean setup_only,
                                                                        gpointer self);
VALA_EXTERN AudienceWelcomePage* audience_welcome_page_new (void);
VALA_EXTERN AudienceWelcomePage* audience_welcome_page_construct (GType object_type);
VALA_EXTERN AudiencePlayerPage* audience_player_page_new (void);
VALA_EXTERN AudiencePlayerPage* audience_player_page_construct (GType object_type);
static void _audience_window_on_player_ended_audience_player_page_ended (AudiencePlayerPage* _sender,
                                                                  gpointer self);
static void _audience_window___lambda93_ (AudienceWindow* self);
static void __audience_window___lambda93__gtk_widget_map (GtkWidget* _sender,
                                                   gpointer self);
static void _audience_window___lambda94_ (AudienceWindow* self);
static void __audience_window___lambda94__gtk_widget_unmap (GtkWidget* _sender,
                                                     gpointer self);
VALA_EXTERN AudienceEpisodesPage* audience_episodes_page_new (void);
VALA_EXTERN AudienceEpisodesPage* audience_episodes_page_construct (GType object_type);
static void _audience_window____lambda95_ (AudienceWindow* self);
static void __audience_window____lambda95__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                          gpointer self);
static void _audience_window___lambda96_ (AudienceWindow* self,
                                   const gchar* video);
static void __audience_window___lambda96__audience_services_library_manager_video_moved_to_trash (AudienceServicesLibraryManager* _sender,
                                                                                           const gchar* path,
                                                                                           gpointer self);
static void _audience_window___lambda97_ (AudienceWindow* self);
static void __audience_window___lambda97__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _audience_window___lambda98_ (AudienceWindow* self);
static void __audience_window___lambda98__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _audience_window___lambda99_ (AudienceWindow* self,
                                   GdkDragContext* ctx,
                                   gint x,
                                   gint y,
                                   GtkSelectionData* sel,
                                   guint info,
                                   guint time);
static void _vala_GFile_free_function_content_of (gpointer data);
static void __audience_window___lambda99__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  gint x,
                                                                  gint y,
                                                                  GtkSelectionData* selection_data,
                                                                  guint info,
                                                                  guint time_,
                                                                  gpointer self);
static gboolean _audience_window___lambda100_ (AudienceWindow* self,
                                        GdkEventButton* event);
static gboolean __audience_window___lambda100__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static gboolean _audience_window___lambda101_ (AudienceWindow* self,
                                        GdkEventKey* event);
static gboolean __audience_window___lambda101__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self);
static gboolean _audience_window___lambda102_ (AudienceWindow* self,
                                        GdkEventWindowState* e);
VALA_EXTERN void audience_player_page_set_fullscreened (AudiencePlayerPage* self,
                                            gboolean value);
static gboolean __audience_window___lambda102__gtk_widget_window_state_event (GtkWidget* _sender,
                                                                       GdkEventWindowState* event,
                                                                       gpointer self);
static gboolean _audience_window___lambda103_ (AudienceWindow* self,
                                        GdkEventConfigure* event);
VALA_EXTERN void audience_player_page_hide_popovers (AudiencePlayerPage* self);
static gboolean __audience_window___lambda103__gtk_widget_configure_event (GtkWidget* _sender,
                                                                    GdkEventConfigure* event,
                                                                    gpointer self);
static gboolean _audience_window___lambda104_ (AudienceWindow* self,
                                        GdkEventMotion* event);
static gboolean __audience_window___lambda104__gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                        GdkEventMotion* event,
                                                                        gpointer self);
static void audience_window_finalize (GObject * obj);
static GType audience_window_get_type_once (void);
static void _vala_audience_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_audience_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry AUDIENCE_WINDOW_ACTION_ENTRIES[6] = {{AUDIENCE_WINDOW_ACTION_BACK, _audience_window_action_back_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_FULLSCREEN, _audience_window_action_fullscreen_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_OPEN_FILE, _audience_window_action_open_file_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_QUIT, _audience_window_action_quit_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_SEARCH, _audience_window_action_search_gsimple_action_activate_callback}, {AUDIENCE_WINDOW_ACTION_UNDO, _audience_window_action_undo_gsimple_action_activate_callback}};

static inline gpointer
audience_window_get_instance_private (AudienceWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AudienceWindow_private_offset);
}

static GType
audience_window_navigation_page_get_type_once (void)
{
	static const GEnumValue values[] = {{AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME, "AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME", "welcome"}, {AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY, "AUDIENCE_WINDOW_NAVIGATION_PAGE_LIBRARY", "library"}, {AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES, "AUDIENCE_WINDOW_NAVIGATION_PAGE_EPISODES", "episodes"}, {0, NULL, NULL}};
	GType audience_window_navigation_page_type_id;
	audience_window_navigation_page_type_id = g_enum_register_static ("AudienceWindowNavigationPage", values);
	return audience_window_navigation_page_type_id;
}

GType
audience_window_navigation_page_get_type (void)
{
	static volatile gsize audience_window_navigation_page_type_id__once = 0;
	if (g_once_init_enter (&audience_window_navigation_page_type_id__once)) {
		GType audience_window_navigation_page_type_id;
		audience_window_navigation_page_type_id = audience_window_navigation_page_get_type_once ();
		g_once_init_leave (&audience_window_navigation_page_type_id__once, audience_window_navigation_page_type_id);
	}
	return audience_window_navigation_page_type_id__once;
}

static void
_audience_window_action_back_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_back ((AudienceWindow*) self);
#line 592 "Window.c"
}

static void
_audience_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_fullscreen ((AudienceWindow*) self);
#line 602 "Window.c"
}

static void
_audience_window_action_open_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_open_file ((AudienceWindow*) self);
#line 612 "Window.c"
}

static void
_audience_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_quit ((AudienceWindow*) self);
#line 622 "Window.c"
}

static void
_audience_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_search ((AudienceWindow*) self);
#line 632 "Window.c"
}

static void
_audience_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 56 "../src/Window.vala"
	audience_window_action_undo ((AudienceWindow*) self);
#line 642 "Window.c"
}

static void
audience_window_action_back (AudienceWindow* self)
{
	HdyDeck* _tmp0_;
#line 278 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 279 "../src/Window.vala"
	hdy_deck_navigate (_tmp0_, HDY_NAVIGATION_DIRECTION_BACK);
#line 655 "Window.c"
}

static void
audience_window_action_fullscreen (AudienceWindow* self)
{
	HdyDeck* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	AudiencePlayerPage* _tmp3_;
#line 282 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 283 "../src/Window.vala"
	_tmp1_ = hdy_deck_get_visible_child (_tmp0_);
#line 283 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 283 "../src/Window.vala"
	_tmp3_ = self->priv->_player_page;
#line 283 "../src/Window.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 677 "Window.c"
		AudiencePlayerPage* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 284 "../src/Window.vala"
		_tmp4_ = self->priv->_player_page;
#line 284 "../src/Window.vala"
		_tmp5_ = audience_player_page_get_fullscreened (_tmp4_);
#line 284 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 284 "../src/Window.vala"
		if (_tmp6_) {
#line 285 "../src/Window.vala"
			gtk_window_unfullscreen ((GtkWindow*) self);
#line 691 "Window.c"
		} else {
#line 287 "../src/Window.vala"
			gtk_window_fullscreen ((GtkWindow*) self);
#line 695 "Window.c"
		}
	}
}

static void
audience_window_action_open_file (AudienceWindow* self)
{
#line 292 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/Window.vala"
	audience_window_run_open_file (self, FALSE, TRUE);
#line 707 "Window.c"
}

static void
audience_window_action_quit (AudienceWindow* self)
{
#line 296 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/Window.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 717 "Window.c"
}

static void
audience_window_action_search (AudienceWindow* self)
{
	GtkSearchEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 300 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Window.vala"
	_tmp0_ = self->priv->search_entry;
#line 301 "../src/Window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 301 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 301 "../src/Window.vala"
	if (_tmp2_) {
#line 736 "Window.c"
		GtkSearchEntry* _tmp3_;
#line 302 "../src/Window.vala"
		_tmp3_ = self->priv->search_entry;
#line 302 "../src/Window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 742 "Window.c"
	} else {
#line 304 "../src/Window.vala"
		gdk_beep ();
#line 746 "Window.c"
	}
}

static void
audience_window_action_undo (AudienceWindow* self)
{
#line 308 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/Window.vala"
	if (!audience_is_sandboxed ()) {
#line 757 "Window.c"
		AudienceServicesLibraryManager* _tmp0_;
		AudienceServicesLibraryManager* _tmp1_;
		GraniteWidgetsToast* _tmp2_;
		HdyDeck* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		AudienceEpisodesPage* _tmp6_;
#line 313 "../src/Window.vala"
		_tmp0_ = audience_services_library_manager_get_instance ();
#line 313 "../src/Window.vala"
		_tmp1_ = _tmp0_;
#line 313 "../src/Window.vala"
		audience_services_library_manager_undo_delete_item (_tmp1_);
#line 313 "../src/Window.vala"
		_g_object_unref0 (_tmp1_);
#line 314 "../src/Window.vala"
		_tmp2_ = self->priv->app_notification;
#line 314 "../src/Window.vala"
		gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp2_, FALSE);
#line 316 "../src/Window.vala"
		_tmp3_ = self->priv->deck;
#line 316 "../src/Window.vala"
		_tmp4_ = hdy_deck_get_visible_child (_tmp3_);
#line 316 "../src/Window.vala"
		_tmp5_ = _tmp4_;
#line 316 "../src/Window.vala"
		_tmp6_ = self->priv->episodes_page;
#line 316 "../src/Window.vala"
		if (_tmp5_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 787 "Window.c"
			HdyDeck* _tmp7_;
			AudienceLibraryPage* _tmp8_;
#line 317 "../src/Window.vala"
			_tmp7_ = self->priv->deck;
#line 317 "../src/Window.vala"
			_tmp8_ = self->priv->library_page;
#line 317 "../src/Window.vala"
			hdy_deck_set_visible_child (_tmp7_, (GtkWidget*) _tmp8_);
#line 796 "Window.c"
		}
	}
}

/** Returns true if the code parameter matches the keycode of the keyval parameter for
    * any keyboard group or level (in order to allow for non-QWERTY keyboards) **/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 330 "../src/Window.vala"
	return self ? g_object_ref (self) : NULL;
#line 808 "Window.c"
}

gboolean
audience_window_match_keycode (AudienceWindow* self,
                               guint keyval,
                               guint code)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkKeymap* keymap = NULL;
	GdkDisplay* _tmp0_;
	GdkKeymap* _tmp1_;
	GdkKeymap* _tmp2_;
	GdkKeymap* _tmp3_;
	GdkKeymapKey* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gboolean result;
#line 325 "../src/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 330 "../src/Window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 330 "../src/Window.vala"
	_tmp1_ = gdk_keymap_get_for_display (_tmp0_);
#line 330 "../src/Window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 330 "../src/Window.vala"
	keymap = _tmp2_;
#line 331 "../src/Window.vala"
	_tmp3_ = keymap;
#line 331 "../src/Window.vala"
	_tmp6_ = gdk_keymap_get_entries_for_keyval (_tmp3_, keyval, &_tmp4_, &_tmp5_);
#line 331 "../src/Window.vala"
	keys = (g_free (keys), NULL);
#line 331 "../src/Window.vala"
	keys = _tmp4_;
#line 331 "../src/Window.vala"
	keys_length1 = _tmp5_;
#line 331 "../src/Window.vala"
	_keys_size_ = keys_length1;
#line 331 "../src/Window.vala"
	if (_tmp6_) {
#line 852 "Window.c"
		GdkKeymapKey* _tmp7_;
		gint _tmp7__length1;
#line 332 "../src/Window.vala"
		_tmp7_ = keys;
#line 332 "../src/Window.vala"
		_tmp7__length1 = keys_length1;
#line 859 "Window.c"
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 332 "../src/Window.vala"
			key_collection = _tmp7_;
#line 332 "../src/Window.vala"
			key_collection_length1 = _tmp7__length1;
#line 332 "../src/Window.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 871 "Window.c"
				GdkKeymapKey key = {0};
#line 332 "../src/Window.vala"
				key = key_collection[key_it];
#line 875 "Window.c"
				{
					GdkKeymapKey _tmp8_;
#line 333 "../src/Window.vala"
					_tmp8_ = key;
#line 333 "../src/Window.vala"
					if (code == _tmp8_.keycode) {
#line 334 "../src/Window.vala"
						result = TRUE;
#line 334 "../src/Window.vala"
						_g_object_unref0 (keymap);
#line 334 "../src/Window.vala"
						keys = (g_free (keys), NULL);
#line 334 "../src/Window.vala"
						return result;
#line 890 "Window.c"
					}
				}
			}
		}
	}
#line 339 "../src/Window.vala"
	result = FALSE;
#line 339 "../src/Window.vala"
	_g_object_unref0 (keymap);
#line 339 "../src/Window.vala"
	keys = (g_free (keys), NULL);
#line 339 "../src/Window.vala"
	return result;
#line 904 "Window.c"
}

static gboolean
audience_window_real_key_press_event (GtkWidget* base,
                                      GdkEventKey* e)
{
	AudienceWindow * self;
	guint keycode = 0U;
	HdyDeck* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	AudiencePlayerPage* _tmp3_;
	gboolean result;
#line 342 "../src/Window.vala"
	self = (AudienceWindow*) base;
#line 342 "../src/Window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 343 "../src/Window.vala"
	keycode = (guint) e->hardware_keycode;
#line 345 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 345 "../src/Window.vala"
	_tmp1_ = hdy_deck_get_visible_child (_tmp0_);
#line 345 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 345 "../src/Window.vala"
	_tmp3_ = self->priv->_player_page;
#line 345 "../src/Window.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 934 "Window.c"
		gboolean shift_pressed = FALSE;
#line 346 "../src/Window.vala"
		if (audience_window_match_keycode (self, GDK_KEY_space, keycode)) {
#line 938 "Window.c"
			GAction* play_pause_action = NULL;
			GApplication* _tmp4_;
			GAction* _tmp5_;
			GAction* _tmp6_;
			GAction* _tmp7_;
#line 347 "../src/Window.vala"
			_tmp4_ = g_application_get_default ();
#line 347 "../src/Window.vala"
			_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 347 "../src/Window.vala"
			_tmp6_ = _g_object_ref0 (_tmp5_);
#line 347 "../src/Window.vala"
			play_pause_action = _tmp6_;
#line 348 "../src/Window.vala"
			_tmp7_ = play_pause_action;
#line 348 "../src/Window.vala"
			g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, g_simple_action_get_type (), GSimpleAction), "activate", NULL);
#line 349 "../src/Window.vala"
			result = TRUE;
#line 349 "../src/Window.vala"
			_g_object_unref0 (play_pause_action);
#line 349 "../src/Window.vala"
			return result;
#line 962 "Window.c"
		} else {
#line 350 "../src/Window.vala"
			if (audience_window_match_keycode (self, GDK_KEY_p, keycode)) {
#line 966 "Window.c"
				GAction* play_pause_action = NULL;
				GApplication* _tmp8_;
				GAction* _tmp9_;
				GAction* _tmp10_;
				GAction* _tmp11_;
#line 351 "../src/Window.vala"
				_tmp8_ = g_application_get_default ();
#line 351 "../src/Window.vala"
				_tmp9_ = g_action_map_lookup_action ((GActionMap*) _tmp8_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 351 "../src/Window.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 351 "../src/Window.vala"
				play_pause_action = _tmp10_;
#line 352 "../src/Window.vala"
				_tmp11_ = play_pause_action;
#line 352 "../src/Window.vala"
				g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_simple_action_get_type (), GSimpleAction), "activate", NULL);
#line 350 "../src/Window.vala"
				_g_object_unref0 (play_pause_action);
#line 986 "Window.c"
			} else {
#line 353 "../src/Window.vala"
				if (audience_window_match_keycode (self, GDK_KEY_a, keycode)) {
#line 990 "Window.c"
					AudiencePlayerPage* _tmp12_;
#line 354 "../src/Window.vala"
					_tmp12_ = self->priv->_player_page;
#line 354 "../src/Window.vala"
					audience_player_page_next_audio (_tmp12_);
#line 996 "Window.c"
				} else {
#line 355 "../src/Window.vala"
					if (audience_window_match_keycode (self, GDK_KEY_s, keycode)) {
#line 1000 "Window.c"
						AudiencePlayerPage* _tmp13_;
#line 356 "../src/Window.vala"
						_tmp13_ = self->priv->_player_page;
#line 356 "../src/Window.vala"
						audience_player_page_next_text (_tmp13_);
#line 1006 "Window.c"
					}
				}
			}
		}
#line 359 "../src/Window.vala"
		shift_pressed = (e->state & GDK_SHIFT_MASK) == GDK_SHIFT_MASK;
#line 360 "../src/Window.vala"
		switch (e->keyval) {
#line 360 "../src/Window.vala"
			case GDK_KEY_Escape:
#line 1017 "Window.c"
			{
				AudiencePlayerPage* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
#line 362 "../src/Window.vala"
				_tmp14_ = self->priv->_player_page;
#line 362 "../src/Window.vala"
				_tmp15_ = audience_player_page_get_fullscreened (_tmp14_);
#line 362 "../src/Window.vala"
				_tmp16_ = _tmp15_;
#line 362 "../src/Window.vala"
				if (_tmp16_) {
#line 363 "../src/Window.vala"
					gtk_window_unfullscreen ((GtkWindow*) self);
#line 1032 "Window.c"
				} else {
#line 365 "../src/Window.vala"
					gtk_widget_destroy ((GtkWidget*) self);
#line 1036 "Window.c"
				}
#line 367 "../src/Window.vala"
				result = TRUE;
#line 367 "../src/Window.vala"
				return result;
#line 1042 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Down:
#line 1046 "Window.c"
			{
				gint _tmp17_ = 0;
				AudiencePlayerPage* _tmp18_;
#line 369 "../src/Window.vala"
				if (shift_pressed) {
#line 369 "../src/Window.vala"
					_tmp17_ = -5;
#line 1054 "Window.c"
				} else {
#line 369 "../src/Window.vala"
					_tmp17_ = -60;
#line 1058 "Window.c"
				}
#line 369 "../src/Window.vala"
				_tmp18_ = self->priv->_player_page;
#line 369 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp18_, _tmp17_);
#line 370 "../src/Window.vala"
				break;
#line 1066 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Left:
#line 1070 "Window.c"
			{
				gint _tmp19_ = 0;
				AudiencePlayerPage* _tmp20_;
#line 372 "../src/Window.vala"
				if (shift_pressed) {
#line 372 "../src/Window.vala"
					_tmp19_ = -1;
#line 1078 "Window.c"
				} else {
#line 372 "../src/Window.vala"
					_tmp19_ = -10;
#line 1082 "Window.c"
				}
#line 372 "../src/Window.vala"
				_tmp20_ = self->priv->_player_page;
#line 372 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp20_, _tmp19_);
#line 373 "../src/Window.vala"
				break;
#line 1090 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Right:
#line 1094 "Window.c"
			{
				gint _tmp21_ = 0;
				AudiencePlayerPage* _tmp22_;
#line 375 "../src/Window.vala"
				if (shift_pressed) {
#line 375 "../src/Window.vala"
					_tmp21_ = 1;
#line 1102 "Window.c"
				} else {
#line 375 "../src/Window.vala"
					_tmp21_ = 10;
#line 1106 "Window.c"
				}
#line 375 "../src/Window.vala"
				_tmp22_ = self->priv->_player_page;
#line 375 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp22_, _tmp21_);
#line 376 "../src/Window.vala"
				break;
#line 1114 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Up:
#line 1118 "Window.c"
			{
				gint _tmp23_ = 0;
				AudiencePlayerPage* _tmp24_;
#line 378 "../src/Window.vala"
				if (shift_pressed) {
#line 378 "../src/Window.vala"
					_tmp23_ = 5;
#line 1126 "Window.c"
				} else {
#line 378 "../src/Window.vala"
					_tmp23_ = 60;
#line 1130 "Window.c"
				}
#line 378 "../src/Window.vala"
				_tmp24_ = self->priv->_player_page;
#line 378 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp24_, _tmp23_);
#line 379 "../src/Window.vala"
				break;
#line 1138 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Page_Down:
#line 1142 "Window.c"
			{
				AudiencePlayerPage* _tmp25_;
#line 381 "../src/Window.vala"
				_tmp25_ = self->priv->_player_page;
#line 381 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp25_, -600);
#line 382 "../src/Window.vala"
				break;
#line 1151 "Window.c"
			}
#line 360 "../src/Window.vala"
			case GDK_KEY_Page_Up:
#line 1155 "Window.c"
			{
				AudiencePlayerPage* _tmp26_;
#line 384 "../src/Window.vala"
				_tmp26_ = self->priv->_player_page;
#line 384 "../src/Window.vala"
				audience_player_page_seek_jump_seconds (_tmp26_, 600);
#line 385 "../src/Window.vala"
				break;
#line 1164 "Window.c"
			}
			default:
			{
#line 387 "../src/Window.vala"
				break;
#line 1170 "Window.c"
			}
		}
	} else {
		HdyDeck* _tmp27_;
		GtkWidget* _tmp28_;
		GtkWidget* _tmp29_;
		AudienceWelcomePage* _tmp30_;
#line 389 "../src/Window.vala"
		_tmp27_ = self->priv->deck;
#line 389 "../src/Window.vala"
		_tmp28_ = hdy_deck_get_visible_child (_tmp27_);
#line 389 "../src/Window.vala"
		_tmp29_ = _tmp28_;
#line 389 "../src/Window.vala"
		_tmp30_ = self->priv->welcome_page;
#line 389 "../src/Window.vala"
		if (_tmp29_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget)) {
#line 1188 "Window.c"
			gboolean ctrl_pressed = FALSE;
			gboolean _tmp31_ = FALSE;
#line 390 "../src/Window.vala"
			ctrl_pressed = (e->state & GDK_CONTROL_MASK) != 0;
#line 391 "../src/Window.vala"
			if (audience_window_match_keycode (self, GDK_KEY_p, keycode)) {
#line 391 "../src/Window.vala"
				_tmp31_ = TRUE;
#line 1197 "Window.c"
			} else {
#line 391 "../src/Window.vala"
				_tmp31_ = audience_window_match_keycode (self, GDK_KEY_space, keycode);
#line 1201 "Window.c"
			}
#line 391 "../src/Window.vala"
			if (_tmp31_) {
#line 392 "../src/Window.vala"
				audience_window_resume_last_videos (self);
#line 393 "../src/Window.vala"
				result = TRUE;
#line 393 "../src/Window.vala"
				return result;
#line 1211 "Window.c"
			} else {
				gboolean _tmp32_ = FALSE;
#line 394 "../src/Window.vala"
				if (ctrl_pressed) {
#line 394 "../src/Window.vala"
					_tmp32_ = audience_window_match_keycode (self, GDK_KEY_b, keycode);
#line 1218 "Window.c"
				} else {
#line 394 "../src/Window.vala"
					_tmp32_ = FALSE;
#line 1222 "Window.c"
				}
#line 394 "../src/Window.vala"
				if (_tmp32_) {
#line 395 "../src/Window.vala"
					audience_window_show_library (self);
#line 396 "../src/Window.vala"
					result = TRUE;
#line 396 "../src/Window.vala"
					return result;
#line 1232 "Window.c"
				}
			}
		}
	}
#line 400 "../src/Window.vala"
	result = GTK_WIDGET_CLASS (audience_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), e);
#line 400 "../src/Window.vala"
	return result;
#line 1241 "Window.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 403 "../src/Window.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 403 "../src/Window.vala"
	return _data1_;
#line 1251 "Window.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 403 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1261 "Window.c"
		AudienceWindow* self;
#line 403 "../src/Window.vala"
		self = _data1_->self;
#line 403 "../src/Window.vala"
		_data1_->videos = (_vala_array_free (_data1_->videos, _data1_->videos_length1, (GDestroyNotify) g_free), NULL);
#line 403 "../src/Window.vala"
		_g_object_unref0 (self);
#line 403 "../src/Window.vala"
		g_slice_free (Block1Data, _data1_);
#line 1271 "Window.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 409 "../src/Window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 409 "../src/Window.vala"
	return _data2_;
#line 1282 "Window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 409 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1292 "Window.c"
		AudienceWindow* self;
#line 409 "../src/Window.vala"
		self = _data2_->_data1_->self;
#line 409 "../src/Window.vala"
		_g_object_unref0 (_data2_->file);
#line 409 "../src/Window.vala"
		block1_data_unref (_data2_->_data1_);
#line 409 "../src/Window.vala"
		_data2_->_data1_ = NULL;
#line 409 "../src/Window.vala"
		g_slice_free (Block2Data, _data2_);
#line 1304 "Window.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 413 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 413 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 413 "../src/Window.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1320 "Window.c"
	}
#line 413 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 413 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1326 "Window.c"
}

static void
_____lambda25_ (Block2Data* _data2_,
                GFile* file_ret)
{
	Block1Data* _data1_;
	AudienceWindow* self;
	AudiencePlayerPage* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
#line 411 "../src/Window.vala"
	_data1_ = _data2_->_data1_;
#line 411 "../src/Window.vala"
	self = _data1_->self;
#line 411 "../src/Window.vala"
	g_return_if_fail (file_ret != NULL);
#line 412 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 412 "../src/Window.vala"
	_tmp1_ = _data2_->file;
#line 412 "../src/Window.vala"
	audience_player_page_append_to_playlist (_tmp0_, _tmp1_);
#line 413 "../src/Window.vala"
	_tmp2_ = g_file_get_uri (file_ret);
#line 413 "../src/Window.vala"
	_vala_array_add1 (&_data1_->videos, &_data1_->videos_length1, &_data1_->_videos_size_, _tmp2_);
#line 1354 "Window.c"
}

static void
______lambda25__audience_func_over_dir (GFile* file_under_dir,
                                        gpointer self)
{
#line 411 "../src/Window.vala"
	_____lambda25_ (self, file_under_dir);
#line 1363 "Window.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 417 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 417 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 417 "../src/Window.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1378 "Window.c"
	}
#line 417 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 417 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1384 "Window.c"
}

void
audience_window_open_files (AudienceWindow* self,
                            GFile** files,
                            gint files_length1,
                            gboolean clear_playlist_items,
                            gboolean force_play)
{
	Block1Data* _data1_;
	gchar** _tmp0_;
	gboolean _tmp8_ = FALSE;
#line 403 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 403 "../src/Window.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 403 "../src/Window.vala"
	_data1_->_ref_count_ = 1;
#line 403 "../src/Window.vala"
	_data1_->self = g_object_ref (self);
#line 404 "../src/Window.vala"
	if (clear_playlist_items) {
#line 405 "../src/Window.vala"
		audience_window_clear_playlist (self, FALSE);
#line 1409 "Window.c"
	}
#line 408 "../src/Window.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 408 "../src/Window.vala"
	_data1_->videos = _tmp0_;
#line 408 "../src/Window.vala"
	_data1_->videos_length1 = 0;
#line 408 "../src/Window.vala"
	_data1_->_videos_size_ = _data1_->videos_length1;
#line 1419 "Window.c"
	{
		GFile** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it = 0;
#line 409 "../src/Window.vala"
		file_collection = files;
#line 409 "../src/Window.vala"
		file_collection_length1 = files_length1;
#line 409 "../src/Window.vala"
		for (file_it = 0; file_it < file_collection_length1; file_it = file_it + 1) {
#line 1431 "Window.c"
			GFile* _tmp1_;
			GFile* file = NULL;
#line 409 "../src/Window.vala"
			_tmp1_ = _g_object_ref0 (file_collection[file_it]);
#line 409 "../src/Window.vala"
			file = _tmp1_;
#line 1438 "Window.c"
			{
				Block2Data* _data2_;
				GFile* _tmp2_;
#line 409 "../src/Window.vala"
				_data2_ = g_slice_new0 (Block2Data);
#line 409 "../src/Window.vala"
				_data2_->_ref_count_ = 1;
#line 409 "../src/Window.vala"
				_data2_->_data1_ = block1_data_ref (_data1_);
#line 409 "../src/Window.vala"
				_data2_->file = file;
#line 410 "../src/Window.vala"
				_tmp2_ = _data2_->file;
#line 410 "../src/Window.vala"
				if (g_file_query_file_type (_tmp2_, 0, NULL) == G_FILE_TYPE_DIRECTORY) {
#line 1454 "Window.c"
					GFile* _tmp3_;
#line 411 "../src/Window.vala"
					_tmp3_ = _data2_->file;
#line 411 "../src/Window.vala"
					audience_recurse_over_dir (_tmp3_, ______lambda25__audience_func_over_dir, _data2_);
#line 1460 "Window.c"
				} else {
					AudiencePlayerPage* _tmp4_;
					GFile* _tmp5_;
					GFile* _tmp6_;
					gchar* _tmp7_;
#line 416 "../src/Window.vala"
					_tmp4_ = self->priv->_player_page;
#line 416 "../src/Window.vala"
					_tmp5_ = _data2_->file;
#line 416 "../src/Window.vala"
					audience_player_page_append_to_playlist (_tmp4_, _tmp5_);
#line 417 "../src/Window.vala"
					_tmp6_ = _data2_->file;
#line 417 "../src/Window.vala"
					_tmp7_ = g_file_get_uri (_tmp6_);
#line 417 "../src/Window.vala"
					_vala_array_add2 (&_data1_->videos, &_data1_->videos_length1, &_data1_->_videos_size_, _tmp7_);
#line 1478 "Window.c"
				}
#line 409 "../src/Window.vala"
				block2_data_unref (_data2_);
#line 409 "../src/Window.vala"
				_data2_ = NULL;
#line 1484 "Window.c"
			}
		}
	}
#line 421 "../src/Window.vala"
	if (force_play) {
#line 1490 "Window.c"
		gchar** _tmp9_;
		gint _tmp9__length1;
#line 421 "../src/Window.vala"
		_tmp9_ = _data1_->videos;
#line 421 "../src/Window.vala"
		_tmp9__length1 = _data1_->videos_length1;
#line 421 "../src/Window.vala"
		_tmp8_ = _tmp9__length1 > 0;
#line 1499 "Window.c"
	} else {
#line 421 "../src/Window.vala"
		_tmp8_ = FALSE;
#line 1503 "Window.c"
	}
#line 421 "../src/Window.vala"
	if (_tmp8_) {
#line 1507 "Window.c"
		gchar* videofile = NULL;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		AudienceWindowNavigationPage page = 0;
		AudienceLibraryPage* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 422 "../src/Window.vala"
		_tmp10_ = _data1_->videos;
#line 422 "../src/Window.vala"
		_tmp10__length1 = _data1_->videos_length1;
#line 422 "../src/Window.vala"
		_tmp11_ = _tmp10_[0];
#line 422 "../src/Window.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 422 "../src/Window.vala"
		videofile = _tmp12_;
#line 423 "../src/Window.vala"
		_tmp13_ = self->priv->library_page;
#line 423 "../src/Window.vala"
		_tmp14_ = videofile;
#line 423 "../src/Window.vala"
		page = audience_library_page_prepare_to_play (_tmp13_, _tmp14_);
#line 424 "../src/Window.vala"
		_tmp15_ = videofile;
#line 424 "../src/Window.vala"
		audience_window_play_file (self, _tmp15_, page, TRUE);
#line 421 "../src/Window.vala"
		_g_free0 (videofile);
#line 1539 "Window.c"
	}
#line 403 "../src/Window.vala"
	block1_data_unref (_data1_);
#line 403 "../src/Window.vala"
	_data1_ = NULL;
#line 1545 "Window.c"
}

void
audience_window_resume_last_videos (AudienceWindow* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 428 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/Window.vala"
	_tmp0_ = audience_settings;
#line 429 "../src/Window.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "current-video");
#line 429 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 429 "../src/Window.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "") != 0;
#line 429 "../src/Window.vala"
	_g_free0 (_tmp2_);
#line 429 "../src/Window.vala"
	if (_tmp3_) {
#line 1569 "Window.c"
		GSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 430 "../src/Window.vala"
		_tmp4_ = audience_settings;
#line 430 "../src/Window.vala"
		_tmp5_ = g_settings_get_string (_tmp4_, "current-video");
#line 430 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 430 "../src/Window.vala"
		audience_window_play_file (self, _tmp6_, AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME, FALSE);
#line 430 "../src/Window.vala"
		_g_free0 (_tmp6_);
#line 1583 "Window.c"
	} else {
#line 432 "../src/Window.vala"
		audience_window_action_open_file (self);
#line 1587 "Window.c"
	}
}

void
audience_window_run_open_dvd (AudienceWindow* self)
{
#line 436 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/Window.vala"
	audience_window_read_first_disk (self, NULL, NULL);
#line 1598 "Window.c"
}

void
audience_window_show_library (AudienceWindow* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	AudienceLibraryPage* _tmp2_;
	HdyDeck* _tmp3_;
	AudienceLibraryPage* _tmp4_;
	HdyDeck* _tmp5_;
	AudienceLibraryPage* _tmp6_;
#line 440 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/Window.vala"
	_tmp0_ = self->priv->navigation_button;
#line 441 "../src/Window.vala"
	gtk_button_set_label (_tmp0_, _ (AUDIENCE_WINDOW_NAVIGATION_BUTTON_WELCOMESCREEN));
#line 442 "../src/Window.vala"
	_tmp1_ = self->priv->navigation_button;
#line 442 "../src/Window.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 444 "../src/Window.vala"
	_tmp2_ = self->priv->library_page;
#line 444 "../src/Window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 446 "../src/Window.vala"
	_tmp3_ = self->priv->deck;
#line 446 "../src/Window.vala"
	_tmp4_ = self->priv->library_page;
#line 446 "../src/Window.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 447 "../src/Window.vala"
	_tmp5_ = self->priv->deck;
#line 447 "../src/Window.vala"
	_tmp6_ = self->priv->library_page;
#line 447 "../src/Window.vala"
	hdy_deck_set_visible_child (_tmp5_, (GtkWidget*) _tmp6_);
#line 1637 "Window.c"
}

void
audience_window_add_to_playlist (AudienceWindow* self,
                                 const gchar* uri,
                                 gboolean preserve_playlist)
{
	AudiencePlayerPage* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GSettings* _tmp3_;
#line 450 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/Window.vala"
	g_return_if_fail (uri != NULL);
#line 451 "../src/Window.vala"
	if (!preserve_playlist) {
#line 452 "../src/Window.vala"
		audience_window_clear_playlist (self, TRUE);
#line 1657 "Window.c"
	}
#line 455 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 455 "../src/Window.vala"
	_tmp1_ = g_file_new_for_uri (uri);
#line 455 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 455 "../src/Window.vala"
	audience_player_page_append_to_playlist (_tmp0_, _tmp2_);
#line 455 "../src/Window.vala"
	_g_object_unref0 (_tmp2_);
#line 456 "../src/Window.vala"
	_tmp3_ = audience_settings;
#line 456 "../src/Window.vala"
	g_settings_set_string (_tmp3_, "current-video", uri);
#line 1673 "Window.c"
}

static void
_vala_array_add3 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 483 "../src/Window.vala"
	if ((*length) == (*size)) {
#line 483 "../src/Window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 483 "../src/Window.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 1688 "Window.c"
	}
#line 483 "../src/Window.vala"
	(*array)[(*length)++] = value;
#line 483 "../src/Window.vala"
	(*array)[*length] = NULL;
#line 1694 "Window.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 482 "../src/Window.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1702 "Window.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 482 "../src/Window.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1710 "Window.c"
}

void
audience_window_run_open_file (AudienceWindow* self,
                               gboolean clear_playlist,
                               gboolean force_play)
{
	GtkFileFilter* all_files_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* video_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileChooserNative* file = NULL;
	GtkFileChooserNative* _tmp6_;
	GtkFileChooserNative* _tmp7_;
	GtkFileChooserNative* _tmp8_;
	GSettings* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkFileChooserNative* _tmp12_;
	GtkFileFilter* _tmp13_;
	GtkFileFilter* _tmp14_;
	GtkFileChooserNative* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserNative* _tmp18_;
	GtkFileChooserNative* _tmp30_;
#line 459 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/Window.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 460 "../src/Window.vala"
	g_object_ref_sink (_tmp0_);
#line 460 "../src/Window.vala"
	all_files_filter = _tmp0_;
#line 461 "../src/Window.vala"
	_tmp1_ = all_files_filter;
#line 461 "../src/Window.vala"
	gtk_file_filter_set_name (_tmp1_, _ ("All files"));
#line 462 "../src/Window.vala"
	_tmp2_ = all_files_filter;
#line 462 "../src/Window.vala"
	gtk_file_filter_add_pattern (_tmp2_, "*");
#line 464 "../src/Window.vala"
	_tmp3_ = gtk_file_filter_new ();
#line 464 "../src/Window.vala"
	g_object_ref_sink (_tmp3_);
#line 464 "../src/Window.vala"
	video_filter = _tmp3_;
#line 465 "../src/Window.vala"
	_tmp4_ = video_filter;
#line 465 "../src/Window.vala"
	gtk_file_filter_set_name (_tmp4_, _ ("Video files"));
#line 466 "../src/Window.vala"
	_tmp5_ = video_filter;
#line 466 "../src/Window.vala"
	gtk_file_filter_add_mime_type (_tmp5_, "video/*");
#line 468 "../src/Window.vala"
	_tmp6_ = gtk_file_chooser_native_new (_ ("Open"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Open"), _ ("_Cancel"));
#line 468 "../src/Window.vala"
	file = _tmp6_;
#line 475 "../src/Window.vala"
	_tmp7_ = file;
#line 475 "../src/Window.vala"
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp7_, TRUE);
#line 476 "../src/Window.vala"
	_tmp8_ = file;
#line 476 "../src/Window.vala"
	_tmp9_ = audience_settings;
#line 476 "../src/Window.vala"
	_tmp10_ = g_settings_get_string (_tmp9_, "last-folder");
#line 476 "../src/Window.vala"
	_tmp11_ = _tmp10_;
#line 476 "../src/Window.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp8_, _tmp11_);
#line 476 "../src/Window.vala"
	_g_free0 (_tmp11_);
#line 477 "../src/Window.vala"
	_tmp12_ = file;
#line 477 "../src/Window.vala"
	_tmp13_ = video_filter;
#line 477 "../src/Window.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 477 "../src/Window.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp12_, _tmp14_);
#line 478 "../src/Window.vala"
	_tmp15_ = file;
#line 478 "../src/Window.vala"
	_tmp16_ = all_files_filter;
#line 478 "../src/Window.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 478 "../src/Window.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp15_, _tmp17_);
#line 480 "../src/Window.vala"
	_tmp18_ = file;
#line 480 "../src/Window.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp18_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1811 "Window.c"
		GFile** files = NULL;
		GFile** _tmp19_;
		gint files_length1;
		gint _files_size_;
		GtkFileChooserNative* _tmp20_;
		GSList* _tmp21_;
		GFile** _tmp25_;
		gint _tmp25__length1;
		GSettings* _tmp26_;
		GtkFileChooserNative* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 481 "../src/Window.vala"
		_tmp19_ = g_new0 (GFile*, 0 + 1);
#line 481 "../src/Window.vala"
		files = _tmp19_;
#line 481 "../src/Window.vala"
		files_length1 = 0;
#line 481 "../src/Window.vala"
		_files_size_ = files_length1;
#line 482 "../src/Window.vala"
		_tmp20_ = file;
#line 482 "../src/Window.vala"
		_tmp21_ = gtk_file_chooser_get_files ((GtkFileChooser*) _tmp20_);
#line 1836 "Window.c"
		{
			GSList* item_collection = NULL;
			GSList* item_it = NULL;
#line 482 "../src/Window.vala"
			item_collection = _tmp21_;
#line 482 "../src/Window.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 1844 "Window.c"
				GFile* _tmp22_;
				GFile* item = NULL;
#line 482 "../src/Window.vala"
				_tmp22_ = _g_object_ref0 ((GFile*) item_it->data);
#line 482 "../src/Window.vala"
				item = _tmp22_;
#line 1851 "Window.c"
				{
					GFile* _tmp23_;
					GFile* _tmp24_;
#line 483 "../src/Window.vala"
					_tmp23_ = item;
#line 483 "../src/Window.vala"
					_tmp24_ = _g_object_ref0 (_tmp23_);
#line 483 "../src/Window.vala"
					_vala_array_add3 (&files, &files_length1, &_files_size_, _tmp24_);
#line 482 "../src/Window.vala"
					_g_object_unref0 (item);
#line 1863 "Window.c"
				}
			}
#line 482 "../src/Window.vala"
			(item_collection == NULL) ? NULL : (item_collection = (_g_slist_free__g_object_unref0_ (item_collection), NULL));
#line 1868 "Window.c"
		}
#line 486 "../src/Window.vala"
		_tmp25_ = files;
#line 486 "../src/Window.vala"
		_tmp25__length1 = files_length1;
#line 486 "../src/Window.vala"
		audience_window_open_files (self, _tmp25_, (gint) _tmp25__length1, clear_playlist, force_play);
#line 487 "../src/Window.vala"
		_tmp26_ = audience_settings;
#line 487 "../src/Window.vala"
		_tmp27_ = file;
#line 487 "../src/Window.vala"
		_tmp28_ = gtk_file_chooser_get_current_folder ((GtkFileChooser*) _tmp27_);
#line 487 "../src/Window.vala"
		_tmp29_ = _tmp28_;
#line 487 "../src/Window.vala"
		g_settings_set_string (_tmp26_, "last-folder", _tmp29_);
#line 487 "../src/Window.vala"
		_g_free0 (_tmp29_);
#line 480 "../src/Window.vala"
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1890 "Window.c"
	}
#line 490 "../src/Window.vala"
	_tmp30_ = file;
#line 490 "../src/Window.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp30_);
#line 459 "../src/Window.vala"
	_g_object_unref0 (file);
#line 459 "../src/Window.vala"
	_g_object_unref0 (video_filter);
#line 459 "../src/Window.vala"
	_g_object_unref0 (all_files_filter);
#line 1902 "Window.c"
}

gboolean
audience_window_is_privacy_mode_enabled (AudienceWindow* self)
{
	GSettings* privacy_settings = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gboolean result;
#line 493 "../src/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 494 "../src/Window.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.privacy");
#line 494 "../src/Window.vala"
	privacy_settings = _tmp0_;
#line 495 "../src/Window.vala"
	_tmp2_ = privacy_settings;
#line 495 "../src/Window.vala"
	if (!g_settings_get_boolean (_tmp2_, "remember-recent-files")) {
#line 495 "../src/Window.vala"
		_tmp1_ = TRUE;
#line 1925 "Window.c"
	} else {
		GSettings* _tmp3_;
#line 495 "../src/Window.vala"
		_tmp3_ = privacy_settings;
#line 495 "../src/Window.vala"
		_tmp1_ = !g_settings_get_boolean (_tmp3_, "remember-app-usage");
#line 1932 "Window.c"
	}
#line 495 "../src/Window.vala"
	result = _tmp1_;
#line 495 "../src/Window.vala"
	_g_object_unref0 (privacy_settings);
#line 495 "../src/Window.vala"
	return result;
#line 1940 "Window.c"
}

static void
audience_window_read_first_disk_data_free (gpointer _data)
{
	AudienceWindowReadFirstDiskData* _data_;
	_data_ = _data;
#line 23 "../src/Window.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/Window.vala"
	g_slice_free (AudienceWindowReadFirstDiskData, _data_);
#line 1952 "Window.c"
}

static void
audience_window_read_first_disk (AudienceWindow* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AudienceWindowReadFirstDiskData* _data_;
	AudienceWindow* _tmp0_;
#line 23 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Window.vala"
	_data_ = g_slice_new0 (AudienceWindowReadFirstDiskData);
#line 23 "../src/Window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/Window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, audience_window_read_first_disk_data_free);
#line 23 "../src/Window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/Window.vala"
	_data_->self = _tmp0_;
#line 23 "../src/Window.vala"
	audience_window_read_first_disk_co (_data_);
#line 1976 "Window.c"
}

static void
audience_window_read_first_disk_finish (AudienceWindow* self,
                                        GAsyncResult* _res_)
{
	AudienceWindowReadFirstDiskData* _data_;
#line 23 "../src/Window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1986 "Window.c"
}

static void
audience_window_read_first_disk_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AudienceWindowReadFirstDiskData* _data_;
#line 507 "../src/Window.vala"
	_data_ = _user_data_;
#line 507 "../src/Window.vala"
	_data_->_source_object_ = source_object;
#line 507 "../src/Window.vala"
	_data_->_res_ = _res_;
#line 507 "../src/Window.vala"
	audience_window_read_first_disk_co (_data_);
#line 2003 "Window.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2025 "Window.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2029 "Window.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2035 "Window.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2039 "Window.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2043 "Window.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 2051 "Window.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2079 "Window.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 2088 "Window.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2102 "Window.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 2111 "Window.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 2125 "Window.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2134 "Window.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 2143 "Window.c"
}

static gboolean
audience_window_read_first_disk_co (AudienceWindowReadFirstDiskData* _data_)
{
#line 498 "../src/Window.vala"
	switch (_data_->_state_) {
#line 498 "../src/Window.vala"
		case 0:
#line 2153 "Window.c"
		goto _state_0;
#line 498 "../src/Window.vala"
		case 1:
#line 2157 "Window.c"
		goto _state_1;
		default:
#line 498 "../src/Window.vala"
		g_assert_not_reached ();
#line 2162 "Window.c"
	}
	_state_0:
#line 499 "../src/Window.vala"
	_data_->_tmp0_ = audience_disk_manager_get_default ();
#line 499 "../src/Window.vala"
	_data_->disk_manager = _data_->_tmp0_;
#line 500 "../src/Window.vala"
	_data_->_tmp1_ = _data_->disk_manager;
#line 500 "../src/Window.vala"
	_data_->_tmp2_ = audience_disk_manager_get_volumes (_data_->_tmp1_);
#line 500 "../src/Window.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 500 "../src/Window.vala"
	_data_->_tmp4_ = gee_collection_get_is_empty ((GeeCollection*) _data_->_tmp3_);
#line 500 "../src/Window.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 500 "../src/Window.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 500 "../src/Window.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 500 "../src/Window.vala"
	if (_data_->_tmp6_) {
#line 501 "../src/Window.vala"
		_g_object_unref0 (_data_->disk_manager);
#line 501 "../src/Window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 501 "../src/Window.vala"
		if (_data_->_state_ != 0) {
#line 501 "../src/Window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 501 "../src/Window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2195 "Window.c"
			}
		}
#line 501 "../src/Window.vala"
		g_object_unref (_data_->_async_result);
#line 501 "../src/Window.vala"
		return FALSE;
#line 2202 "Window.c"
	}
#line 504 "../src/Window.vala"
	_data_->_tmp7_ = _data_->disk_manager;
#line 504 "../src/Window.vala"
	_data_->_tmp8_ = audience_disk_manager_get_volumes (_data_->_tmp7_);
#line 504 "../src/Window.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 504 "../src/Window.vala"
	_data_->_tmp10_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _data_->_tmp9_);
#line 504 "../src/Window.vala"
	_data_->_tmp11_ = (GVolume*) _data_->_tmp10_;
#line 504 "../src/Window.vala"
	_g_object_unref0 (_data_->_tmp9_);
#line 504 "../src/Window.vala"
	_data_->volume = _data_->_tmp11_;
#line 505 "../src/Window.vala"
	_data_->_tmp13_ = _data_->volume;
#line 505 "../src/Window.vala"
	if (g_volume_can_mount (_data_->_tmp13_) == TRUE) {
#line 505 "../src/Window.vala"
		_data_->_tmp14_ = _data_->volume;
#line 505 "../src/Window.vala"
		_data_->_tmp15_ = g_volume_get_mount (_data_->_tmp14_);
#line 505 "../src/Window.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 505 "../src/Window.vala"
		_data_->_tmp12_ = g_mount_can_unmount (_data_->_tmp16_) == FALSE;
#line 505 "../src/Window.vala"
		_g_object_unref0 (_data_->_tmp16_);
#line 2232 "Window.c"
	} else {
#line 505 "../src/Window.vala"
		_data_->_tmp12_ = FALSE;
#line 2236 "Window.c"
	}
#line 505 "../src/Window.vala"
	if (_data_->_tmp12_) {
#line 2240 "Window.c"
		{
#line 507 "../src/Window.vala"
			_data_->_tmp17_ = _data_->volume;
#line 507 "../src/Window.vala"
			_data_->_state_ = 1;
#line 507 "../src/Window.vala"
			g_volume_mount (_data_->_tmp17_, G_MOUNT_MOUNT_NONE, NULL, NULL, audience_window_read_first_disk_ready, _data_);
#line 507 "../src/Window.vala"
			return FALSE;
#line 2250 "Window.c"
			_state_1:
#line 507 "../src/Window.vala"
			g_volume_mount_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
#line 507 "../src/Window.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2256 "Window.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 506 "../src/Window.vala"
			_data_->e = _data_->_inner_error0_;
#line 506 "../src/Window.vala"
			_data_->_inner_error0_ = NULL;
#line 509 "../src/Window.vala"
			_data_->_tmp18_ = _data_->e;
#line 509 "../src/Window.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 509 "../src/Window.vala"
			g_critical ("Window.vala:509: %s", _data_->_tmp19_);
#line 506 "../src/Window.vala"
			_g_error_free0 (_data_->e);
#line 2275 "Window.c"
		}
		__finally0:
#line 506 "../src/Window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 506 "../src/Window.vala"
			_g_object_unref0 (_data_->volume);
#line 506 "../src/Window.vala"
			_g_object_unref0 (_data_->disk_manager);
#line 506 "../src/Window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 506 "../src/Window.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 506 "../src/Window.vala"
			g_object_unref (_data_->_async_result);
#line 506 "../src/Window.vala"
			return FALSE;
#line 2292 "Window.c"
		}
	}
#line 513 "../src/Window.vala"
	_data_->_tmp20_ = _data_->volume;
#line 513 "../src/Window.vala"
	_data_->_tmp21_ = g_volume_get_mount (_data_->_tmp20_);
#line 513 "../src/Window.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 513 "../src/Window.vala"
	_data_->_tmp23_ = g_mount_get_default_location (_data_->_tmp22_);
#line 513 "../src/Window.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 513 "../src/Window.vala"
	_g_object_unref0 (_data_->_tmp22_);
#line 513 "../src/Window.vala"
	_data_->root = _data_->_tmp24_;
#line 514 "../src/Window.vala"
	_data_->_tmp25_ = _data_->root;
#line 514 "../src/Window.vala"
	_data_->_tmp26_ = g_file_get_uri (_data_->_tmp25_);
#line 514 "../src/Window.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 514 "../src/Window.vala"
	_data_->_tmp28_ = string_replace (_data_->_tmp27_, "file:///", "dvd:///");
#line 514 "../src/Window.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 514 "../src/Window.vala"
	audience_window_play_file (_data_->self, _data_->_tmp29_, AUDIENCE_WINDOW_NAVIGATION_PAGE_WELCOME, TRUE);
#line 514 "../src/Window.vala"
	_g_free0 (_data_->_tmp29_);
#line 514 "../src/Window.vala"
	_g_free0 (_data_->_tmp27_);
#line 498 "../src/Window.vala"
	_g_object_unref0 (_data_->root);
#line 498 "../src/Window.vala"
	_g_object_unref0 (_data_->volume);
#line 498 "../src/Window.vala"
	_g_object_unref0 (_data_->disk_manager);
#line 498 "../src/Window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 498 "../src/Window.vala"
	if (_data_->_state_ != 0) {
#line 498 "../src/Window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 498 "../src/Window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2339 "Window.c"
		}
	}
#line 498 "../src/Window.vala"
	g_object_unref (_data_->_async_result);
#line 498 "../src/Window.vala"
	return FALSE;
#line 2346 "Window.c"
}

static void
audience_window_on_player_ended (AudienceWindow* self)
{
	HdyDeck* _tmp0_;
#line 517 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 518 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 518 "../src/Window.vala"
	hdy_deck_navigate (_tmp0_, HDY_NAVIGATION_DIRECTION_BACK);
#line 519 "../src/Window.vala"
	gtk_window_unfullscreen ((GtkWindow*) self);
#line 2361 "Window.c"
}

void
audience_window_play_file (AudienceWindow* self,
                           const gchar* uri,
                           AudienceWindowNavigationPage origin,
                           gboolean from_beginning)
{
	AudiencePlayerPage* _tmp0_;
	HdyDeck* _tmp1_;
	AudiencePlayerPage* _tmp2_;
	HdyDeck* _tmp3_;
	AudiencePlayerPage* _tmp4_;
	AudiencePlayerPage* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 522 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/Window.vala"
	g_return_if_fail (uri != NULL);
#line 523 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 523 "../src/Window.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
#line 525 "../src/Window.vala"
	_tmp1_ = self->priv->deck;
#line 525 "../src/Window.vala"
	_tmp2_ = self->priv->_player_page;
#line 525 "../src/Window.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp2_);
#line 526 "../src/Window.vala"
	_tmp3_ = self->priv->deck;
#line 526 "../src/Window.vala"
	_tmp4_ = self->priv->_player_page;
#line 526 "../src/Window.vala"
	hdy_deck_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 528 "../src/Window.vala"
	_tmp5_ = self->priv->_player_page;
#line 528 "../src/Window.vala"
	audience_player_page_play_file (_tmp5_, uri, from_beginning);
#line 529 "../src/Window.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp6_, NULL);
#line 529 "../src/Window.vala"
	_tmp7_ = _tmp6_;
#line 529 "../src/Window.vala"
	if (_tmp7_) {
#line 530 "../src/Window.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 2410 "Window.c"
	}
}

void
audience_window_clear_playlist (AudienceWindow* self,
                                gboolean should_stop)
{
	AudiencePlayerPage* _tmp0_;
	AudienceWidgetsPlaylist* _tmp1_;
	AudienceWidgetsPlaylist* _tmp2_;
#line 534 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 535 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 535 "../src/Window.vala"
	_tmp1_ = audience_player_page_get_playlist_widget (_tmp0_);
#line 535 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 535 "../src/Window.vala"
	audience_widgets_playlist_clear_items (_tmp2_, should_stop);
#line 535 "../src/Window.vala"
	_g_object_unref0 (_tmp2_);
#line 2433 "Window.c"
}

void
audience_window_append_to_playlist (AudienceWindow* self,
                                    GFile* file)
{
	AudiencePlayerPage* _tmp0_;
#line 538 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 538 "../src/Window.vala"
	g_return_if_fail (file != NULL);
#line 539 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 539 "../src/Window.vala"
	audience_player_page_append_to_playlist (_tmp0_, file);
#line 2449 "Window.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 542 "../src/Window.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 542 "../src/Window.vala"
	return _data3_;
#line 2459 "Window.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 542 "../src/Window.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2469 "Window.c"
		AudienceWindow* self;
#line 542 "../src/Window.vala"
		self = _data3_->self;
#line 542 "../src/Window.vala"
		_g_object_unref0 (_data3_->play_pause_action);
#line 542 "../src/Window.vala"
		_g_object_unref0 (self);
#line 542 "../src/Window.vala"
		g_slice_free (Block3Data, _data3_);
#line 2479 "Window.c"
	}
}

static GVariant*
_variant_new3 (gboolean value)
{
#line 549 "../src/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2488 "Window.c"
}

static GVariant*
_variant_new4 (gboolean value)
{
#line 570 "../src/Window.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2496 "Window.c"
}

static gboolean
___lambda88_ (Block3Data* _data3_)
{
	AudienceWindow* self;
	GdkWindow* _tmp0_;
	HdyDeck* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	AudienceWelcomePage* _tmp4_;
	GtkWidget* previous_child = NULL;
	HdyDeck* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	AudienceWelcomePage* _tmp28_;
	GtkWidget* next_child = NULL;
	HdyDeck* _tmp42_;
	GtkWidget* _tmp43_;
	GtkWidget* _tmp44_;
	GtkWidget* _tmp45_;
	gboolean result;
#line 555 "../src/Window.vala"
	self = _data3_->self;
#line 556 "../src/Window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 556 "../src/Window.vala"
	gdk_window_set_cursor (_tmp0_, NULL);
#line 558 "../src/Window.vala"
	_tmp1_ = self->priv->deck;
#line 558 "../src/Window.vala"
	_tmp2_ = hdy_deck_get_visible_child (_tmp1_);
#line 558 "../src/Window.vala"
	_tmp3_ = _tmp2_;
#line 558 "../src/Window.vala"
	_tmp4_ = self->priv->welcome_page;
#line 558 "../src/Window.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 2536 "Window.c"
		GtkSearchEntry* _tmp5_;
#line 559 "../src/Window.vala"
		gtk_window_set_title ((GtkWindow*) self, _ ("Videos"));
#line 560 "../src/Window.vala"
		_tmp5_ = self->priv->search_entry;
#line 560 "../src/Window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 2544 "Window.c"
	} else {
		HdyDeck* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		AudienceLibraryPage* _tmp9_;
#line 561 "../src/Window.vala"
		_tmp6_ = self->priv->deck;
#line 561 "../src/Window.vala"
		_tmp7_ = hdy_deck_get_visible_child (_tmp6_);
#line 561 "../src/Window.vala"
		_tmp8_ = _tmp7_;
#line 561 "../src/Window.vala"
		_tmp9_ = self->priv->library_page;
#line 561 "../src/Window.vala"
		if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 2560 "Window.c"
			GtkSearchEntry* _tmp10_;
#line 562 "../src/Window.vala"
			gtk_window_set_title ((GtkWindow*) self, _ ("Library"));
#line 563 "../src/Window.vala"
			_tmp10_ = self->priv->search_entry;
#line 563 "../src/Window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp10_, TRUE);
#line 2568 "Window.c"
		} else {
			HdyDeck* _tmp11_;
			GtkWidget* _tmp12_;
			GtkWidget* _tmp13_;
			AudienceEpisodesPage* _tmp14_;
#line 564 "../src/Window.vala"
			_tmp11_ = self->priv->deck;
#line 564 "../src/Window.vala"
			_tmp12_ = hdy_deck_get_visible_child (_tmp11_);
#line 564 "../src/Window.vala"
			_tmp13_ = _tmp12_;
#line 564 "../src/Window.vala"
			_tmp14_ = self->priv->episodes_page;
#line 564 "../src/Window.vala"
			if (_tmp13_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget)) {
#line 2584 "Window.c"
				GtkSearchEntry* _tmp15_;
#line 565 "../src/Window.vala"
				_tmp15_ = self->priv->search_entry;
#line 565 "../src/Window.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp15_, TRUE);
#line 2590 "Window.c"
			} else {
				HdyDeck* _tmp16_;
				GtkWidget* _tmp17_;
				GtkWidget* _tmp18_;
				AudiencePlayerPage* _tmp19_;
#line 566 "../src/Window.vala"
				_tmp16_ = self->priv->deck;
#line 566 "../src/Window.vala"
				_tmp17_ = hdy_deck_get_visible_child (_tmp16_);
#line 566 "../src/Window.vala"
				_tmp18_ = _tmp17_;
#line 566 "../src/Window.vala"
				_tmp19_ = self->priv->_player_page;
#line 566 "../src/Window.vala"
				if (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget)) {
#line 2606 "Window.c"
					GtkSearchEntry* _tmp20_;
					GtkButton* _tmp21_;
					GAction* _tmp22_;
					GVariant* _tmp23_;
#line 567 "../src/Window.vala"
					_tmp20_ = self->priv->search_entry;
#line 567 "../src/Window.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp20_, FALSE);
#line 568 "../src/Window.vala"
					_tmp21_ = self->priv->navigation_button;
#line 568 "../src/Window.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
#line 570 "../src/Window.vala"
					_tmp22_ = _data3_->play_pause_action;
#line 570 "../src/Window.vala"
					_tmp23_ = _variant_new4 (TRUE);
#line 570 "../src/Window.vala"
					g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, g_simple_action_get_type (), GSimpleAction), _tmp23_);
#line 570 "../src/Window.vala"
					_g_variant_unref0 (_tmp23_);
#line 2627 "Window.c"
				}
			}
		}
	}
#line 573 "../src/Window.vala"
	_tmp24_ = self->priv->deck;
#line 573 "../src/Window.vala"
	_tmp25_ = hdy_deck_get_adjacent_child (_tmp24_, HDY_NAVIGATION_DIRECTION_BACK);
#line 573 "../src/Window.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 573 "../src/Window.vala"
	previous_child = _tmp26_;
#line 574 "../src/Window.vala"
	_tmp27_ = previous_child;
#line 574 "../src/Window.vala"
	_tmp28_ = self->priv->welcome_page;
#line 574 "../src/Window.vala"
	if (_tmp27_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_widget_get_type (), GtkWidget)) {
#line 2646 "Window.c"
		GtkButton* _tmp29_;
		GraniteModeSwitch* _tmp30_;
#line 575 "../src/Window.vala"
		_tmp29_ = self->priv->navigation_button;
#line 575 "../src/Window.vala"
		gtk_button_set_label (_tmp29_, _ (AUDIENCE_WINDOW_NAVIGATION_BUTTON_WELCOMESCREEN));
#line 576 "../src/Window.vala"
		_tmp30_ = self->priv->autoqueue_next;
#line 576 "../src/Window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, FALSE);
#line 2657 "Window.c"
	} else {
		GtkWidget* _tmp31_;
		AudienceLibraryPage* _tmp32_;
#line 577 "../src/Window.vala"
		_tmp31_ = previous_child;
#line 577 "../src/Window.vala"
		_tmp32_ = self->priv->library_page;
#line 577 "../src/Window.vala"
		if (_tmp31_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_widget_get_type (), GtkWidget)) {
#line 2667 "Window.c"
			GtkButton* _tmp33_;
			GraniteModeSwitch* _tmp34_;
#line 578 "../src/Window.vala"
			_tmp33_ = self->priv->navigation_button;
#line 578 "../src/Window.vala"
			gtk_button_set_label (_tmp33_, _ (AUDIENCE_WINDOW_NAVIGATION_BUTTON_LIBRARY));
#line 579 "../src/Window.vala"
			_tmp34_ = self->priv->autoqueue_next;
#line 579 "../src/Window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp34_, TRUE);
#line 2678 "Window.c"
		} else {
			GtkWidget* _tmp35_;
			AudienceEpisodesPage* _tmp36_;
#line 580 "../src/Window.vala"
			_tmp35_ = previous_child;
#line 580 "../src/Window.vala"
			_tmp36_ = self->priv->episodes_page;
#line 580 "../src/Window.vala"
			if (_tmp35_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget)) {
#line 2688 "Window.c"
				GtkButton* _tmp37_;
				GraniteModeSwitch* _tmp38_;
#line 581 "../src/Window.vala"
				_tmp37_ = self->priv->navigation_button;
#line 581 "../src/Window.vala"
				gtk_button_set_label (_tmp37_, _ (AUDIENCE_WINDOW_NAVIGATION_BUTTON_EPISODES));
#line 582 "../src/Window.vala"
				_tmp38_ = self->priv->autoqueue_next;
#line 582 "../src/Window.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp38_, TRUE);
#line 2699 "Window.c"
			} else {
				GtkButton* _tmp39_;
				GtkSearchEntry* _tmp40_;
				GraniteModeSwitch* _tmp41_;
#line 584 "../src/Window.vala"
				_tmp39_ = self->priv->navigation_button;
#line 584 "../src/Window.vala"
				gtk_widget_hide ((GtkWidget*) _tmp39_);
#line 585 "../src/Window.vala"
				_tmp40_ = self->priv->search_entry;
#line 585 "../src/Window.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
#line 586 "../src/Window.vala"
				_tmp41_ = self->priv->autoqueue_next;
#line 586 "../src/Window.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp41_, FALSE);
#line 2716 "Window.c"
			}
		}
	}
#line 589 "../src/Window.vala"
	_tmp42_ = self->priv->deck;
#line 589 "../src/Window.vala"
	_tmp43_ = hdy_deck_get_adjacent_child (_tmp42_, HDY_NAVIGATION_DIRECTION_FORWARD);
#line 589 "../src/Window.vala"
	_tmp44_ = _g_object_ref0 (_tmp43_);
#line 589 "../src/Window.vala"
	next_child = _tmp44_;
#line 590 "../src/Window.vala"
	_tmp45_ = next_child;
#line 590 "../src/Window.vala"
	if (_tmp45_ != NULL) {
#line 2732 "Window.c"
		HdyDeck* _tmp46_;
		GtkWidget* _tmp47_;
#line 591 "../src/Window.vala"
		_tmp46_ = self->priv->deck;
#line 591 "../src/Window.vala"
		_tmp47_ = next_child;
#line 591 "../src/Window.vala"
		gtk_container_remove ((GtkContainer*) _tmp46_, _tmp47_);
#line 2741 "Window.c"
	}
#line 594 "../src/Window.vala"
	result = G_SOURCE_REMOVE;
#line 594 "../src/Window.vala"
	_g_object_unref0 (next_child);
#line 594 "../src/Window.vala"
	_g_object_unref0 (previous_child);
#line 594 "../src/Window.vala"
	return result;
#line 2751 "Window.c"
}

static gboolean
____lambda88__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda88_ (self);
#line 555 "../src/Window.vala"
	return result;
#line 2761 "Window.c"
}

static void
audience_window_update_navigation (AudienceWindow* self)
{
	Block3Data* _data3_;
	gdouble progress = 0.0;
	AudiencePlayerPage* _tmp0_;
	GApplication* _tmp2_;
	GAction* _tmp3_;
	GAction* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
	HdyDeck* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 542 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 542 "../src/Window.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 542 "../src/Window.vala"
	_data3_->_ref_count_ = 1;
#line 542 "../src/Window.vala"
	_data3_->self = g_object_ref (self);
#line 543 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 543 "../src/Window.vala"
	progress = audience_player_page_get_progress (_tmp0_);
#line 544 "../src/Window.vala"
	if (progress > ((gdouble) 0)) {
#line 2792 "Window.c"
		GSettings* _tmp1_;
#line 545 "../src/Window.vala"
		_tmp1_ = audience_settings;
#line 545 "../src/Window.vala"
		g_settings_set_double (_tmp1_, "last-stopped", progress);
#line 2798 "Window.c"
	}
#line 548 "../src/Window.vala"
	_tmp2_ = g_application_get_default ();
#line 548 "../src/Window.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) _tmp2_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 548 "../src/Window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 548 "../src/Window.vala"
	_data3_->play_pause_action = _tmp4_;
#line 549 "../src/Window.vala"
	_tmp5_ = _data3_->play_pause_action;
#line 549 "../src/Window.vala"
	_tmp6_ = _variant_new3 (FALSE);
#line 549 "../src/Window.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 549 "../src/Window.vala"
	_g_variant_unref0 (_tmp6_);
#line 551 "../src/Window.vala"
	_tmp7_ = self->priv->deck;
#line 551 "../src/Window.vala"
	_tmp8_ = hdy_deck_get_transition_running (_tmp7_);
#line 551 "../src/Window.vala"
	_tmp9_ = _tmp8_;
#line 551 "../src/Window.vala"
	if (!_tmp9_) {
#line 555 "../src/Window.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda88__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 2826 "Window.c"
	}
#line 542 "../src/Window.vala"
	block3_data_unref (_data3_);
#line 542 "../src/Window.vala"
	_data3_ = NULL;
#line 2832 "Window.c"
}

void
audience_window_hide_mouse_cursor (AudienceWindow* self)
{
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkWindow* _tmp3_;
#line 599 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/Window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 600 "../src/Window.vala"
	_tmp1_ = gdk_window_get_display (_tmp0_);
#line 600 "../src/Window.vala"
	_tmp2_ = gdk_cursor_new_for_display (_tmp1_, GDK_BLANK_CURSOR);
#line 600 "../src/Window.vala"
	cursor = _tmp2_;
#line 601 "../src/Window.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
#line 601 "../src/Window.vala"
	gdk_window_set_cursor (_tmp3_, cursor);
#line 599 "../src/Window.vala"
	_g_object_unref0 (cursor);
#line 2859 "Window.c"
}

void
audience_window_show_mouse_cursor (AudienceWindow* self)
{
	GdkWindow* _tmp0_;
#line 604 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/Window.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 605 "../src/Window.vala"
	gdk_window_set_cursor (_tmp0_, NULL);
#line 2872 "Window.c"
}

gboolean
audience_window_autoqueue_next_active (AudienceWindow* self)
{
	GraniteModeSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 608 "../src/Window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 609 "../src/Window.vala"
	_tmp0_ = self->priv->autoqueue_next;
#line 609 "../src/Window.vala"
	_tmp1_ = granite_mode_switch_get_active (_tmp0_);
#line 609 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 609 "../src/Window.vala"
	result = _tmp2_;
#line 609 "../src/Window.vala"
	return result;
#line 2894 "Window.c"
}

AudienceWindow*
audience_window_construct (GType object_type)
{
	AudienceWindow * self = NULL;
#line 23 "../src/Window.vala"
	self = (AudienceWindow*) g_object_new (object_type, NULL);
#line 23 "../src/Window.vala"
	return self;
#line 2905 "Window.c"
}

AudienceWindow*
audience_window_new (void)
{
#line 23 "../src/Window.vala"
	return audience_window_construct (AUDIENCE_TYPE_WINDOW);
#line 2913 "Window.c"
}

AudiencePlayerPage*
audience_window_get_player_page (AudienceWindow* self)
{
	AudiencePlayerPage* result;
	AudiencePlayerPage* _tmp0_;
#line 34 "../src/Window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 34 "../src/Window.vala"
	result = _tmp0_;
#line 34 "../src/Window.vala"
	return result;
#line 2929 "Window.c"
}

static void
audience_window_set_player_page (AudienceWindow* self,
                                 AudiencePlayerPage* value)
{
	AudiencePlayerPage* old_value;
#line 34 "../src/Window.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Window.vala"
	old_value = audience_window_get_player_page (self);
#line 34 "../src/Window.vala"
	if (old_value != value) {
#line 2943 "Window.c"
		AudiencePlayerPage* _tmp0_;
#line 34 "../src/Window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Window.vala"
		_g_object_unref0 (self->priv->_player_page);
#line 34 "../src/Window.vala"
		self->priv->_player_page = _tmp0_;
#line 34 "../src/Window.vala"
		g_object_notify_by_pspec ((GObject *) self, audience_window_properties[AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY]);
#line 2953 "Window.c"
	}
}

static void
_audience_window___lambda89_ (AudienceWindow* self)
{
	HdyDeck* _tmp0_;
#line 100 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 100 "../src/Window.vala"
	hdy_deck_navigate (_tmp0_, HDY_NAVIGATION_DIRECTION_BACK);
#line 2965 "Window.c"
}

static void
__audience_window___lambda89__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 99 "../src/Window.vala"
	_audience_window___lambda89_ ((AudienceWindow*) self);
#line 2974 "Window.c"
}

static void
_audience_window___lambda90_ (AudienceWindow* self)
{
	HdyDeck* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	AudienceEpisodesPage* _tmp3_;
#line 109 "../src/Window.vala"
	_tmp0_ = self->priv->deck;
#line 109 "../src/Window.vala"
	_tmp1_ = hdy_deck_get_visible_child (_tmp0_);
#line 109 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/Window.vala"
	_tmp3_ = self->priv->episodes_page;
#line 109 "../src/Window.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 2994 "Window.c"
		AudienceEpisodesPage* _tmp4_;
		GtkSearchEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 110 "../src/Window.vala"
		_tmp4_ = self->priv->episodes_page;
#line 110 "../src/Window.vala"
		_tmp5_ = self->priv->search_entry;
#line 110 "../src/Window.vala"
		_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
#line 110 "../src/Window.vala"
		_tmp7_ = _tmp6_;
#line 110 "../src/Window.vala"
		audience_episodes_page_filter (_tmp4_, _tmp7_);
#line 3009 "Window.c"
	} else {
		AudienceLibraryPage* _tmp8_;
		GtkSearchEntry* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 112 "../src/Window.vala"
		_tmp8_ = self->priv->library_page;
#line 112 "../src/Window.vala"
		_tmp9_ = self->priv->search_entry;
#line 112 "../src/Window.vala"
		_tmp10_ = gtk_entry_get_text ((GtkEntry*) _tmp9_);
#line 112 "../src/Window.vala"
		_tmp11_ = _tmp10_;
#line 112 "../src/Window.vala"
		audience_library_page_filter (_tmp8_, _tmp11_);
#line 3025 "Window.c"
	}
}

static void
__audience_window___lambda90__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                               gpointer self)
{
#line 108 "../src/Window.vala"
	_audience_window___lambda90_ ((AudienceWindow*) self);
#line 3035 "Window.c"
}

static void
_audience_window___lambda91_ (AudienceWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	AudienceLibraryPage* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 130 "../src/Window.vala"
	_tmp1_ = self->priv->search_entry;
#line 130 "../src/Window.vala"
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
#line 130 "../src/Window.vala"
	_tmp3_ = _tmp2_;
#line 130 "../src/Window.vala"
	if (g_strcmp0 (_tmp3_, "") != 0) {
#line 3056 "Window.c"
		AudienceLibraryPage* _tmp4_;
#line 130 "../src/Window.vala"
		_tmp4_ = self->priv->library_page;
#line 130 "../src/Window.vala"
		_tmp0_ = !audience_library_page_has_child (_tmp4_);
#line 3062 "Window.c"
	} else {
#line 130 "../src/Window.vala"
		_tmp0_ = FALSE;
#line 3066 "Window.c"
	}
#line 130 "../src/Window.vala"
	if (_tmp0_) {
#line 3070 "Window.c"
		GtkSearchEntry* _tmp5_;
#line 131 "../src/Window.vala"
		_tmp5_ = self->priv->search_entry;
#line 131 "../src/Window.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp5_, "");
#line 3076 "Window.c"
	}
#line 133 "../src/Window.vala"
	_tmp6_ = self->priv->library_page;
#line 133 "../src/Window.vala"
	_tmp7_ = audience_library_page_get_last_filter (_tmp6_);
#line 133 "../src/Window.vala"
	_tmp8_ = _tmp7_;
#line 133 "../src/Window.vala"
	if (g_strcmp0 (_tmp8_, "") != 0) {
#line 3086 "Window.c"
		GtkSearchEntry* _tmp9_;
		AudienceLibraryPage* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		AudienceLibraryPage* _tmp13_;
#line 134 "../src/Window.vala"
		_tmp9_ = self->priv->search_entry;
#line 134 "../src/Window.vala"
		_tmp10_ = self->priv->library_page;
#line 134 "../src/Window.vala"
		_tmp11_ = audience_library_page_get_last_filter (_tmp10_);
#line 134 "../src/Window.vala"
		_tmp12_ = _tmp11_;
#line 134 "../src/Window.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp9_, _tmp12_);
#line 135 "../src/Window.vala"
		_tmp13_ = self->priv->library_page;
#line 135 "../src/Window.vala"
		audience_library_page_set_last_filter (_tmp13_, "");
#line 3106 "Window.c"
	}
}

static void
__audience_window___lambda91__gtk_widget_map (GtkWidget* _sender,
                                              gpointer self)
{
#line 129 "../src/Window.vala"
	_audience_window___lambda91_ ((AudienceWindow*) self);
#line 3116 "Window.c"
}

static void
_audience_window___lambda92_ (AudienceWindow* self,
                              AudienceLibraryItem* item,
                              gboolean setup_only)
{
	AudienceEpisodesPage* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	AudienceEpisodesPage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
#line 139 "../src/Window.vala"
	g_return_if_fail (item != NULL);
#line 140 "../src/Window.vala"
	_tmp0_ = self->priv->episodes_page;
#line 140 "../src/Window.vala"
	_tmp1_ = audience_library_item_get_episodes (item);
#line 140 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 140 "../src/Window.vala"
	audience_episodes_page_set_episodes_items (_tmp0_, _tmp2_);
#line 141 "../src/Window.vala"
	_tmp3_ = self->priv->episodes_page;
#line 141 "../src/Window.vala"
	_tmp4_ = audience_episodes_page_get_poster (_tmp3_);
#line 141 "../src/Window.vala"
	_tmp5_ = _tmp4_;
#line 141 "../src/Window.vala"
	_tmp6_ = audience_library_item_get_poster (item);
#line 141 "../src/Window.vala"
	_tmp7_ = _tmp6_;
#line 141 "../src/Window.vala"
	g_object_get (_tmp7_, "pixbuf", &_tmp8_, NULL);
#line 141 "../src/Window.vala"
	_tmp9_ = _tmp8_;
#line 141 "../src/Window.vala"
	_tmp10_ = _tmp9_;
#line 141 "../src/Window.vala"
	g_object_set (_tmp5_, "pixbuf", _tmp10_, NULL);
#line 141 "../src/Window.vala"
	_g_object_unref0 (_tmp10_);
#line 142 "../src/Window.vala"
	if (!setup_only) {
#line 3167 "Window.c"
		AudienceEpisodesPage* _tmp11_;
		HdyDeck* _tmp12_;
		AudienceEpisodesPage* _tmp13_;
		HdyDeck* _tmp14_;
		AudienceEpisodesPage* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GtkSearchEntry* _tmp18_;
		GraniteModeSwitch* _tmp19_;
#line 143 "../src/Window.vala"
		_tmp11_ = self->priv->episodes_page;
#line 143 "../src/Window.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp11_);
#line 145 "../src/Window.vala"
		_tmp12_ = self->priv->deck;
#line 145 "../src/Window.vala"
		_tmp13_ = self->priv->episodes_page;
#line 145 "../src/Window.vala"
		gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 146 "../src/Window.vala"
		_tmp14_ = self->priv->deck;
#line 146 "../src/Window.vala"
		_tmp15_ = self->priv->episodes_page;
#line 146 "../src/Window.vala"
		hdy_deck_set_visible_child (_tmp14_, (GtkWidget*) _tmp15_);
#line 148 "../src/Window.vala"
		_tmp16_ = audience_library_item_get_title (item);
#line 148 "../src/Window.vala"
		_tmp17_ = _tmp16_;
#line 148 "../src/Window.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp17_);
#line 148 "../src/Window.vala"
		_g_free0 (_tmp17_);
#line 149 "../src/Window.vala"
		_tmp18_ = self->priv->search_entry;
#line 149 "../src/Window.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp18_, "");
#line 150 "../src/Window.vala"
		_tmp19_ = self->priv->autoqueue_next;
#line 150 "../src/Window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp19_, TRUE);
#line 3209 "Window.c"
	}
}

static void
__audience_window___lambda92__audience_library_page_show_episodes (AudienceLibraryPage* _sender,
                                                                   AudienceLibraryItem* item,
                                                                   gboolean setup_only,
                                                                   gpointer self)
{
#line 139 "../src/Window.vala"
	_audience_window___lambda92_ ((AudienceWindow*) self, item, setup_only);
#line 3221 "Window.c"
}

static void
_audience_window_on_player_ended_audience_player_page_ended (AudiencePlayerPage* _sender,
                                                             gpointer self)
{
#line 157 "../src/Window.vala"
	audience_window_on_player_ended ((AudienceWindow*) self);
#line 3230 "Window.c"
}

static void
_audience_window___lambda93_ (AudienceWindow* self)
{
	GraniteWidgetsToast* _tmp0_;
#line 160 "../src/Window.vala"
	_tmp0_ = self->priv->app_notification;
#line 160 "../src/Window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 3241 "Window.c"
}

static void
__audience_window___lambda93__gtk_widget_map (GtkWidget* _sender,
                                              gpointer self)
{
#line 159 "../src/Window.vala"
	_audience_window___lambda93_ ((AudienceWindow*) self);
#line 3250 "Window.c"
}

static void
_audience_window___lambda94_ (AudienceWindow* self)
{
	GraniteWidgetsToast* _tmp0_;
#line 163 "../src/Window.vala"
	_tmp0_ = self->priv->app_notification;
#line 163 "../src/Window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 3261 "Window.c"
}

static void
__audience_window___lambda94__gtk_widget_unmap (GtkWidget* _sender,
                                                gpointer self)
{
#line 162 "../src/Window.vala"
	_audience_window___lambda94_ ((AudienceWindow*) self);
#line 3270 "Window.c"
}

static void
_audience_window____lambda95_ (AudienceWindow* self)
{
#line 183 "../src/Window.vala"
	audience_window_action_undo (self);
#line 3278 "Window.c"
}

static void
__audience_window____lambda95__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                     gpointer self)
{
#line 182 "../src/Window.vala"
	_audience_window____lambda95_ ((AudienceWindow*) self);
#line 3287 "Window.c"
}

static void
_audience_window___lambda96_ (AudienceWindow* self,
                              const gchar* video)
{
	GraniteWidgetsToast* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteWidgetsToast* _tmp5_;
#line 198 "../src/Window.vala"
	g_return_if_fail (video != NULL);
#line 199 "../src/Window.vala"
	_tmp0_ = self->priv->app_notification;
#line 199 "../src/Window.vala"
	_tmp1_ = g_path_get_basename (video);
#line 199 "../src/Window.vala"
	_tmp2_ = _tmp1_;
#line 199 "../src/Window.vala"
	_tmp3_ = g_strdup_printf (_ ("Video '%s' Removed."), _tmp2_);
#line 199 "../src/Window.vala"
	_tmp4_ = _tmp3_;
#line 199 "../src/Window.vala"
	granite_widgets_toast_set_title (_tmp0_, _tmp4_);
#line 199 "../src/Window.vala"
	_g_free0 (_tmp4_);
#line 199 "../src/Window.vala"
	_g_free0 (_tmp2_);
#line 200 "../src/Window.vala"
	_tmp5_ = self->priv->app_notification;
#line 200 "../src/Window.vala"
	granite_widgets_toast_send_notification (_tmp5_);
#line 3322 "Window.c"
}

static void
__audience_window___lambda96__audience_services_library_manager_video_moved_to_trash (AudienceServicesLibraryManager* _sender,
                                                                                      const gchar* path,
                                                                                      gpointer self)
{
#line 198 "../src/Window.vala"
	_audience_window___lambda96_ ((AudienceWindow*) self, path);
#line 3332 "Window.c"
}

static void
_audience_window___lambda97_ (AudienceWindow* self)
{
#line 204 "../src/Window.vala"
	audience_window_update_navigation (self);
#line 3340 "Window.c"
}

static void
__audience_window___lambda97__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 203 "../src/Window.vala"
	_audience_window___lambda97_ ((AudienceWindow*) self);
#line 3350 "Window.c"
}

static void
_audience_window___lambda98_ (AudienceWindow* self)
{
#line 208 "../src/Window.vala"
	audience_window_update_navigation (self);
#line 3358 "Window.c"
}

static void
__audience_window___lambda98__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 207 "../src/Window.vala"
	_audience_window___lambda98_ ((AudienceWindow*) self);
#line 3368 "Window.c"
}

static void
_vala_GFile_free_function_content_of (gpointer data)
{
	GFile* self;
#line 214 "../src/Window.vala"
	self = *((GFile**) data);
#line 214 "../src/Window.vala"
	_g_object_unref0_ (self);
#line 3379 "Window.c"
}

static void
_audience_window___lambda99_ (AudienceWindow* self,
                              GdkDragContext* ctx,
                              gint x,
                              gint y,
                              GtkSelectionData* sel,
                              guint info,
                              guint time)
{
	GArray* files = NULL;
	GArray* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	GArray* _tmp9_;
	gpointer* _tmp10_;
	gint _tmp10__length1;
#line 213 "../src/Window.vala"
	g_return_if_fail (ctx != NULL);
#line 213 "../src/Window.vala"
	g_return_if_fail (sel != NULL);
#line 214 "../src/Window.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (GFile*));
#line 214 "../src/Window.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_GFile_free_function_content_of);
#line 214 "../src/Window.vala"
	files = _tmp0_;
#line 215 "../src/Window.vala"
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (sel);
#line 3410 "Window.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 215 "../src/Window.vala"
		uri_collection = _tmp2_;
#line 215 "../src/Window.vala"
		uri_collection_length1 = _vala_array_length (_tmp1_);
#line 215 "../src/Window.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 3422 "Window.c"
			gchar* _tmp3_;
			gchar* uri = NULL;
#line 215 "../src/Window.vala"
			_tmp3_ = g_strdup (uri_collection[uri_it]);
#line 215 "../src/Window.vala"
			uri = _tmp3_;
#line 3429 "Window.c"
			{
				GFile* file = NULL;
				const gchar* _tmp4_;
				GFile* _tmp5_;
				GArray* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
#line 216 "../src/Window.vala"
				_tmp4_ = uri;
#line 216 "../src/Window.vala"
				_tmp5_ = g_file_new_for_uri (_tmp4_);
#line 216 "../src/Window.vala"
				file = _tmp5_;
#line 217 "../src/Window.vala"
				_tmp6_ = files;
#line 217 "../src/Window.vala"
				_tmp7_ = file;
#line 217 "../src/Window.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 217 "../src/Window.vala"
				g_array_append_val (_tmp6_, _tmp8_);
#line 215 "../src/Window.vala"
				_g_object_unref0 (file);
#line 215 "../src/Window.vala"
				_g_free0 (uri);
#line 3455 "Window.c"
			}
		}
#line 215 "../src/Window.vala"
		uri_collection = (_vala_array_free (uri_collection, uri_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3460 "Window.c"
	}
#line 220 "../src/Window.vala"
	_tmp9_ = files;
#line 220 "../src/Window.vala"
	_tmp10_ = _tmp9_->data;
#line 220 "../src/Window.vala"
	_tmp10__length1 = _tmp9_->len;
#line 220 "../src/Window.vala"
	audience_window_open_files (self, _tmp10_, (gint) _tmp10__length1, FALSE, FALSE);
#line 213 "../src/Window.vala"
	_g_array_unref0 (files);
#line 3472 "Window.c"
}

static void
__audience_window___lambda99__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gint x,
                                                             gint y,
                                                             GtkSelectionData* selection_data,
                                                             guint info,
                                                             guint time_,
                                                             gpointer self)
{
#line 213 "../src/Window.vala"
	_audience_window___lambda99_ ((AudienceWindow*) self, context, x, y, selection_data, info, time_);
#line 3487 "Window.c"
}

static gboolean
_audience_window___lambda100_ (AudienceWindow* self,
                               GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 223 "../src/Window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 225 "../src/Window.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 225 "../src/Window.vala"
		_tmp0_ = event->type == GDK_2BUTTON_PRESS;
#line 3502 "Window.c"
	} else {
#line 225 "../src/Window.vala"
		_tmp0_ = FALSE;
#line 3506 "Window.c"
	}
#line 225 "../src/Window.vala"
	if (_tmp0_) {
#line 226 "../src/Window.vala"
		audience_window_action_fullscreen (self);
#line 3512 "Window.c"
	}
#line 230 "../src/Window.vala"
	if (event->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 3516 "Window.c"
		GAction* play_pause_action = NULL;
		GApplication* _tmp1_;
		GAction* _tmp2_;
		GAction* _tmp3_;
		GAction* _tmp4_;
#line 231 "../src/Window.vala"
		_tmp1_ = g_application_get_default ();
#line 231 "../src/Window.vala"
		_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, AUDIENCE_APP_ACTION_PLAY_PAUSE);
#line 231 "../src/Window.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 231 "../src/Window.vala"
		play_pause_action = _tmp3_;
#line 232 "../src/Window.vala"
		_tmp4_ = play_pause_action;
#line 232 "../src/Window.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_simple_action_get_type (), GSimpleAction), "activate", NULL);
#line 230 "../src/Window.vala"
		_g_object_unref0 (play_pause_action);
#line 3536 "Window.c"
	}
#line 235 "../src/Window.vala"
	result = GTK_WIDGET_CLASS (audience_window_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 235 "../src/Window.vala"
	return result;
#line 3542 "Window.c"
}

static gboolean
__audience_window___lambda100__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _audience_window___lambda100_ ((AudienceWindow*) self, event);
#line 223 "../src/Window.vala"
	return result;
#line 3554 "Window.c"
}

static gboolean
_audience_window___lambda101_ (AudienceWindow* self,
                               GdkEventKey* event)
{
	gboolean result;
#line 238 "../src/Window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 239 "../src/Window.vala"
	if (event->keyval == GDK_KEY_Escape) {
#line 3566 "Window.c"
		GtkSearchEntry* _tmp0_;
#line 240 "../src/Window.vala"
		_tmp0_ = self->priv->search_entry;
#line 240 "../src/Window.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp0_, "");
#line 3572 "Window.c"
	}
#line 243 "../src/Window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 243 "../src/Window.vala"
	return result;
#line 3578 "Window.c"
}

static gboolean
__audience_window___lambda101__gtk_widget_key_press_event (GtkWidget* _sender,
                                                           GdkEventKey* event,
                                                           gpointer self)
{
	gboolean result;
	result = _audience_window___lambda101_ ((AudienceWindow*) self, event);
#line 238 "../src/Window.vala"
	return result;
#line 3590 "Window.c"
}

static gboolean
_audience_window___lambda102_ (AudienceWindow* self,
                               GdkEventWindowState* e)
{
	gboolean result;
#line 246 "../src/Window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 247 "../src/Window.vala"
	if ((e->changed_mask & GDK_WINDOW_STATE_FULLSCREEN) == GDK_WINDOW_STATE_FULLSCREEN) {
#line 3602 "Window.c"
		AudiencePlayerPage* _tmp0_;
		GtkHeaderBar* _tmp1_;
		AudiencePlayerPage* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		AudiencePlayerPage* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 248 "../src/Window.vala"
		_tmp0_ = self->priv->_player_page;
#line 248 "../src/Window.vala"
		audience_player_page_set_fullscreened (_tmp0_, (e->new_window_state & GDK_WINDOW_STATE_FULLSCREEN) == GDK_WINDOW_STATE_FULLSCREEN);
#line 249 "../src/Window.vala"
		_tmp1_ = self->priv->header;
#line 249 "../src/Window.vala"
		_tmp2_ = self->priv->_player_page;
#line 249 "../src/Window.vala"
		_tmp3_ = audience_player_page_get_fullscreened (_tmp2_);
#line 249 "../src/Window.vala"
		_tmp4_ = _tmp3_;
#line 249 "../src/Window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, !_tmp4_);
#line 251 "../src/Window.vala"
		_tmp5_ = self->priv->_player_page;
#line 251 "../src/Window.vala"
		_tmp6_ = audience_player_page_get_fullscreened (_tmp5_);
#line 251 "../src/Window.vala"
		_tmp7_ = _tmp6_;
#line 251 "../src/Window.vala"
		if (!_tmp7_) {
#line 252 "../src/Window.vala"
			gtk_window_unmaximize ((GtkWindow*) self);
#line 3635 "Window.c"
		}
	}
#line 256 "../src/Window.vala"
	if ((e->changed_mask & GDK_WINDOW_STATE_MAXIMIZED) == GDK_WINDOW_STATE_MAXIMIZED) {
#line 3640 "Window.c"
		gboolean currently_maximixed = FALSE;
		gboolean _tmp8_ = FALSE;
		HdyDeck* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		AudiencePlayerPage* _tmp12_;
#line 257 "../src/Window.vala"
		currently_maximixed = (e->new_window_state & GDK_WINDOW_STATE_MAXIMIZED) == GDK_WINDOW_STATE_MAXIMIZED;
#line 259 "../src/Window.vala"
		_tmp9_ = self->priv->deck;
#line 259 "../src/Window.vala"
		_tmp10_ = hdy_deck_get_visible_child (_tmp9_);
#line 259 "../src/Window.vala"
		_tmp11_ = _tmp10_;
#line 259 "../src/Window.vala"
		_tmp12_ = self->priv->_player_page;
#line 259 "../src/Window.vala"
		if (_tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget)) {
#line 259 "../src/Window.vala"
			_tmp8_ = currently_maximixed;
#line 3661 "Window.c"
		} else {
#line 259 "../src/Window.vala"
			_tmp8_ = FALSE;
#line 3665 "Window.c"
		}
#line 259 "../src/Window.vala"
		if (_tmp8_) {
#line 260 "../src/Window.vala"
			gtk_window_fullscreen ((GtkWindow*) self);
#line 3671 "Window.c"
		}
	}
#line 264 "../src/Window.vala"
	result = FALSE;
#line 264 "../src/Window.vala"
	return result;
#line 3678 "Window.c"
}

static gboolean
__audience_window___lambda102__gtk_widget_window_state_event (GtkWidget* _sender,
                                                              GdkEventWindowState* event,
                                                              gpointer self)
{
	gboolean result;
	result = _audience_window___lambda102_ ((AudienceWindow*) self, event);
#line 246 "../src/Window.vala"
	return result;
#line 3690 "Window.c"
}

static gboolean
_audience_window___lambda103_ (AudienceWindow* self,
                               GdkEventConfigure* event)
{
	AudiencePlayerPage* _tmp0_;
	gboolean result;
#line 267 "../src/Window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 268 "../src/Window.vala"
	_tmp0_ = self->priv->_player_page;
#line 268 "../src/Window.vala"
	audience_player_page_hide_popovers (_tmp0_);
#line 269 "../src/Window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 269 "../src/Window.vala"
	return result;
#line 3709 "Window.c"
}

static gboolean
__audience_window___lambda103__gtk_widget_configure_event (GtkWidget* _sender,
                                                           GdkEventConfigure* event,
                                                           gpointer self)
{
	gboolean result;
	result = _audience_window___lambda103_ ((AudienceWindow*) self, event);
#line 267 "../src/Window.vala"
	return result;
#line 3721 "Window.c"
}

static gboolean
_audience_window___lambda104_ (AudienceWindow* self,
                               GdkEventMotion* event)
{
	gboolean result;
#line 272 "../src/Window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 273 "../src/Window.vala"
	audience_window_show_mouse_cursor (self);
#line 274 "../src/Window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 274 "../src/Window.vala"
	return result;
#line 3737 "Window.c"
}

static gboolean
__audience_window___lambda104__gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                               GdkEventMotion* event,
                                                               gpointer self)
{
	gboolean result;
	result = _audience_window___lambda104_ ((AudienceWindow*) self, event);
#line 272 "../src/Window.vala"
	return result;
#line 3749 "Window.c"
}

static GObject *
audience_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudienceWindow * self;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkHeaderBar* _tmp21_;
	GtkHeaderBar* _tmp22_;
	GtkHeaderBar* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkButton* _tmp25_ = NULL;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkButton* _tmp28_;
	GtkHeaderBar* _tmp29_;
	GtkButton* _tmp30_;
	GtkSearchEntry* _tmp31_;
	GtkSearchEntry* _tmp32_;
	GtkSearchEntry* _tmp33_;
	GtkSearchEntry* _tmp34_;
	GtkHeaderBar* _tmp35_;
	GtkSearchEntry* _tmp36_;
	GraniteModeSwitch* _tmp37_;
	GraniteModeSwitch* _tmp38_;
	GraniteModeSwitch* _tmp39_;
	GraniteModeSwitch* _tmp40_;
	GSettings* _tmp41_;
	GraniteModeSwitch* _tmp42_;
	GtkHeaderBar* _tmp43_;
	GraniteModeSwitch* _tmp44_;
	GtkHeaderBar* _tmp45_;
	AudienceLibraryPage* _tmp46_;
	AudienceLibraryPage* _tmp47_;
	AudienceLibraryPage* _tmp48_;
	AudienceWelcomePage* _tmp49_;
	AudiencePlayerPage* _tmp50_;
	AudiencePlayerPage* _tmp51_;
	AudiencePlayerPage* _tmp52_;
	AudiencePlayerPage* _tmp53_;
	AudiencePlayerPage* _tmp54_;
	AudienceEpisodesPage* _tmp55_;
	HdyDeck* _tmp56_ = NULL;
	HdyDeck* _tmp57_;
	AudienceWelcomePage* _tmp58_;
	AudienceServicesLibraryManager* manager = NULL;
	AudienceServicesLibraryManager* _tmp59_;
	GraniteWidgetsToast* _tmp60_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp63_;
	GtkOverlay* _tmp64_;
	HdyDeck* _tmp65_;
	GtkOverlay* _tmp66_;
	GraniteWidgetsToast* _tmp67_;
	GtkOverlay* _tmp68_;
	GtkButton* _tmp69_;
	GtkSearchEntry* _tmp70_;
	GraniteModeSwitch* _tmp71_;
	AudienceServicesLibraryManager* _tmp72_;
	HdyDeck* _tmp73_;
	HdyDeck* _tmp74_;
	GtkTargetEntry uris = {0};
	GtkTargetEntry _tmp75_ = {0};
	GtkTargetEntry _tmp76_;
	GtkTargetEntry* _tmp77_;
	GtkTargetEntry* _tmp78_;
	gint _tmp78__length1;
	AudiencePlayerPage* _tmp79_;
	GtkSearchEntry* _tmp80_;
#line 76 "../src/Window.vala"
	parent_class = G_OBJECT_CLASS (audience_window_parent_class);
#line 76 "../src/Window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 76 "../src/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 77 "../src/Window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, AUDIENCE_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (AUDIENCE_WINDOW_ACTION_ENTRIES), self);
#line 79 "../src/Window.vala"
	_tmp0_ = g_application_get_default ();
#line 79 "../src/Window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 79 "../src/Window.vala"
	application_instance = _tmp1_;
#line 3839 "Window.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 80 "../src/Window.vala"
		_tmp2_ = audience_window_action_accelerators;
#line 80 "../src/Window.vala"
		_tmp3_ = gee_multi_map_get_keys (_tmp2_);
#line 80 "../src/Window.vala"
		_tmp4_ = _tmp3_;
#line 80 "../src/Window.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 80 "../src/Window.vala"
		_tmp6_ = _tmp5_;
#line 80 "../src/Window.vala"
		_g_object_unref0 (_tmp4_);
#line 80 "../src/Window.vala"
		_action_it = _tmp6_;
#line 80 "../src/Window.vala"
		while (TRUE) {
#line 3863 "Window.c"
			GeeIterator* _tmp7_;
			gchar* action = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GtkApplication* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GeeMultiMap* _tmp14_;
			const gchar* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gint _tmp18_ = 0;
			gpointer* _tmp19_;
			gchar** _tmp20_;
			gint _tmp20__length1;
#line 80 "../src/Window.vala"
			_tmp7_ = _action_it;
#line 80 "../src/Window.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 80 "../src/Window.vala"
				break;
#line 3886 "Window.c"
			}
#line 80 "../src/Window.vala"
			_tmp8_ = _action_it;
#line 80 "../src/Window.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 80 "../src/Window.vala"
			action = (gchar*) _tmp9_;
#line 81 "../src/Window.vala"
			_tmp10_ = application_instance;
#line 81 "../src/Window.vala"
			_tmp11_ = action;
#line 81 "../src/Window.vala"
			_tmp12_ = g_strconcat (AUDIENCE_WINDOW_ACTION_PREFIX, _tmp11_, NULL);
#line 81 "../src/Window.vala"
			_tmp13_ = _tmp12_;
#line 81 "../src/Window.vala"
			_tmp14_ = audience_window_action_accelerators;
#line 81 "../src/Window.vala"
			_tmp15_ = action;
#line 81 "../src/Window.vala"
			_tmp16_ = gee_multi_map_get (_tmp14_, _tmp15_);
#line 81 "../src/Window.vala"
			_tmp17_ = _tmp16_;
#line 81 "../src/Window.vala"
			_tmp19_ = gee_collection_to_array (_tmp17_, &_tmp18_);
#line 81 "../src/Window.vala"
			_tmp20_ = _tmp19_;
#line 81 "../src/Window.vala"
			_tmp20__length1 = _tmp18_;
#line 81 "../src/Window.vala"
			gtk_application_set_accels_for_action (_tmp10_, _tmp13_, _tmp20_);
#line 81 "../src/Window.vala"
			_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/Window.vala"
			_g_object_unref0 (_tmp17_);
#line 81 "../src/Window.vala"
			_g_free0 (_tmp13_);
#line 80 "../src/Window.vala"
			_g_free0 (action);
#line 3926 "Window.c"
		}
#line 80 "../src/Window.vala"
		_g_object_unref0 (_action_it);
#line 3930 "Window.c"
	}
#line 86 "../src/Window.vala"
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER, NULL);
#line 87 "../src/Window.vala"
	gtk_window_set_gravity ((GtkWindow*) self, GDK_GRAVITY_CENTER);
#line 88 "../src/Window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 1000, 680);
#line 90 "../src/Window.vala"
	_tmp21_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 90 "../src/Window.vala"
	g_object_ref_sink (_tmp21_);
#line 90 "../src/Window.vala"
	_g_object_unref0 (self->priv->header);
#line 90 "../src/Window.vala"
	self->priv->header = _tmp21_;
#line 91 "../src/Window.vala"
	_tmp22_ = self->priv->header;
#line 91 "../src/Window.vala"
	gtk_header_bar_set_show_close_button (_tmp22_, TRUE);
#line 92 "../src/Window.vala"
	_tmp23_ = self->priv->header;
#line 92 "../src/Window.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
#line 92 "../src/Window.vala"
	gtk_style_context_add_class (_tmp24_, "compact");
#line 94 "../src/Window.vala"
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (AUDIENCE_WINDOW_NAVIGATION_BUTTON_WELCOMESCREEN);
#line 94 "../src/Window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
#line 94 "../src/Window.vala"
	g_object_ref_sink (_tmp25_);
#line 94 "../src/Window.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 94 "../src/Window.vala"
	self->priv->navigation_button = _tmp25_;
#line 97 "../src/Window.vala"
	_tmp26_ = self->priv->navigation_button;
#line 97 "../src/Window.vala"
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 97 "../src/Window.vala"
	gtk_style_context_add_class (_tmp27_, GRANITE_STYLE_CLASS_BACK_BUTTON);
#line 99 "../src/Window.vala"
	_tmp28_ = self->priv->navigation_button;
#line 99 "../src/Window.vala"
	g_signal_connect_object (_tmp28_, "clicked", (GCallback) __audience_window___lambda89__gtk_button_clicked, self, 0);
#line 103 "../src/Window.vala"
	_tmp29_ = self->priv->header;
#line 103 "../src/Window.vala"
	_tmp30_ = self->priv->navigation_button;
#line 103 "../src/Window.vala"
	gtk_header_bar_pack_start (_tmp29_, (GtkWidget*) _tmp30_);
#line 105 "../src/Window.vala"
	_tmp31_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 105 "../src/Window.vala"
	g_object_ref_sink (_tmp31_);
#line 105 "../src/Window.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 105 "../src/Window.vala"
	self->priv->search_entry = _tmp31_;
#line 106 "../src/Window.vala"
	_tmp32_ = self->priv->search_entry;
#line 106 "../src/Window.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp32_, _ ("Search Videos"));
#line 107 "../src/Window.vala"
	_tmp33_ = self->priv->search_entry;
#line 107 "../src/Window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
#line 108 "../src/Window.vala"
	_tmp34_ = self->priv->search_entry;
#line 108 "../src/Window.vala"
	g_signal_connect_object (_tmp34_, "search-changed", (GCallback) __audience_window___lambda90__gtk_search_entry_search_changed, self, 0);
#line 116 "../src/Window.vala"
	_tmp35_ = self->priv->header;
#line 116 "../src/Window.vala"
	_tmp36_ = self->priv->search_entry;
#line 116 "../src/Window.vala"
	gtk_header_bar_pack_end (_tmp35_, (GtkWidget*) _tmp36_);
#line 118 "../src/Window.vala"
	_tmp37_ = granite_mode_switch_new_from_icon_name ("media-playlist-repeat-one-symbolic", "media-playlist-consecutive-symbolic");
#line 118 "../src/Window.vala"
	g_object_ref_sink (_tmp37_);
#line 118 "../src/Window.vala"
	_g_object_unref0 (self->priv->autoqueue_next);
#line 118 "../src/Window.vala"
	self->priv->autoqueue_next = _tmp37_;
#line 119 "../src/Window.vala"
	_tmp38_ = self->priv->autoqueue_next;
#line 119 "../src/Window.vala"
	granite_mode_switch_set_primary_icon_tooltip_text (_tmp38_, _ ("Play one video"));
#line 120 "../src/Window.vala"
	_tmp39_ = self->priv->autoqueue_next;
#line 120 "../src/Window.vala"
	granite_mode_switch_set_secondary_icon_tooltip_text (_tmp39_, _ ("Automatically play next videos"));
#line 121 "../src/Window.vala"
	_tmp40_ = self->priv->autoqueue_next;
#line 121 "../src/Window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp40_, GTK_ALIGN_CENTER);
#line 122 "../src/Window.vala"
	_tmp41_ = audience_settings;
#line 122 "../src/Window.vala"
	_tmp42_ = self->priv->autoqueue_next;
#line 122 "../src/Window.vala"
	g_settings_bind (_tmp41_, "autoqueue-next", (GObject*) _tmp42_, "active", G_SETTINGS_BIND_DEFAULT);
#line 124 "../src/Window.vala"
	_tmp43_ = self->priv->header;
#line 124 "../src/Window.vala"
	_tmp44_ = self->priv->autoqueue_next;
#line 124 "../src/Window.vala"
	gtk_header_bar_pack_end (_tmp43_, (GtkWidget*) _tmp44_);
#line 126 "../src/Window.vala"
	_tmp45_ = self->priv->header;
#line 126 "../src/Window.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp45_);
#line 128 "../src/Window.vala"
	_tmp46_ = audience_library_page_get_instance ();
#line 128 "../src/Window.vala"
	_g_object_unref0 (self->priv->library_page);
#line 128 "../src/Window.vala"
	self->priv->library_page = _tmp46_;
#line 129 "../src/Window.vala"
	_tmp47_ = self->priv->library_page;
#line 129 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp47_, "map", (GCallback) __audience_window___lambda91__gtk_widget_map, self, 0);
#line 139 "../src/Window.vala"
	_tmp48_ = self->priv->library_page;
#line 139 "../src/Window.vala"
	g_signal_connect_object (_tmp48_, "show-episodes", (GCallback) __audience_window___lambda92__audience_library_page_show_episodes, self, 0);
#line 154 "../src/Window.vala"
	_tmp49_ = audience_welcome_page_new ();
#line 154 "../src/Window.vala"
	g_object_ref_sink (_tmp49_);
#line 154 "../src/Window.vala"
	_g_object_unref0 (self->priv->welcome_page);
#line 154 "../src/Window.vala"
	self->priv->welcome_page = _tmp49_;
#line 156 "../src/Window.vala"
	_tmp50_ = audience_player_page_new ();
#line 156 "../src/Window.vala"
	g_object_ref_sink (_tmp50_);
#line 156 "../src/Window.vala"
	_tmp51_ = _tmp50_;
#line 156 "../src/Window.vala"
	audience_window_set_player_page (self, _tmp51_);
#line 156 "../src/Window.vala"
	_g_object_unref0 (_tmp51_);
#line 157 "../src/Window.vala"
	_tmp52_ = self->priv->_player_page;
#line 157 "../src/Window.vala"
	g_signal_connect_object (_tmp52_, "ended", (GCallback) _audience_window_on_player_ended_audience_player_page_ended, self, 0);
#line 159 "../src/Window.vala"
	_tmp53_ = self->priv->_player_page;
#line 159 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp53_, "map", (GCallback) __audience_window___lambda93__gtk_widget_map, self, 0);
#line 162 "../src/Window.vala"
	_tmp54_ = self->priv->_player_page;
#line 162 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp54_, "unmap", (GCallback) __audience_window___lambda94__gtk_widget_unmap, self, 0);
#line 166 "../src/Window.vala"
	_tmp55_ = audience_episodes_page_new ();
#line 166 "../src/Window.vala"
	g_object_ref_sink (_tmp55_);
#line 166 "../src/Window.vala"
	_g_object_unref0 (self->priv->episodes_page);
#line 166 "../src/Window.vala"
	self->priv->episodes_page = _tmp55_;
#line 168 "../src/Window.vala"
	_tmp56_ = (HdyDeck*) hdy_deck_new ();
#line 168 "../src/Window.vala"
	hdy_deck_set_can_swipe_back (_tmp56_, TRUE);
#line 168 "../src/Window.vala"
	g_object_ref_sink (_tmp56_);
#line 168 "../src/Window.vala"
	_g_object_unref0 (self->priv->deck);
#line 168 "../src/Window.vala"
	self->priv->deck = _tmp56_;
#line 171 "../src/Window.vala"
	_tmp57_ = self->priv->deck;
#line 171 "../src/Window.vala"
	_tmp58_ = self->priv->welcome_page;
#line 171 "../src/Window.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 173 "../src/Window.vala"
	_tmp59_ = audience_services_library_manager_get_instance ();
#line 173 "../src/Window.vala"
	manager = _tmp59_;
#line 174 "../src/Window.vala"
	_tmp60_ = granite_widgets_toast_new ("");
#line 174 "../src/Window.vala"
	g_object_ref_sink (_tmp60_);
#line 174 "../src/Window.vala"
	_g_object_unref0 (self->priv->app_notification);
#line 174 "../src/Window.vala"
	self->priv->app_notification = _tmp60_;
#line 179 "../src/Window.vala"
	if (!audience_is_sandboxed ()) {
#line 4126 "Window.c"
		GraniteWidgetsToast* _tmp61_;
		GraniteWidgetsToast* _tmp62_;
#line 180 "../src/Window.vala"
		_tmp61_ = self->priv->app_notification;
#line 180 "../src/Window.vala"
		granite_widgets_toast_set_default_action (_tmp61_, _ ("Restore"));
#line 182 "../src/Window.vala"
		_tmp62_ = self->priv->app_notification;
#line 182 "../src/Window.vala"
		g_signal_connect_object (_tmp62_, "default-action", (GCallback) __audience_window____lambda95__granite_widgets_toast_default_action, self, 0);
#line 4137 "Window.c"
	}
#line 187 "../src/Window.vala"
	_tmp63_ = (GtkOverlay*) gtk_overlay_new ();
#line 187 "../src/Window.vala"
	g_object_ref_sink (_tmp63_);
#line 187 "../src/Window.vala"
	overlay = _tmp63_;
#line 188 "../src/Window.vala"
	_tmp64_ = overlay;
#line 188 "../src/Window.vala"
	_tmp65_ = self->priv->deck;
#line 188 "../src/Window.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
#line 189 "../src/Window.vala"
	_tmp66_ = overlay;
#line 189 "../src/Window.vala"
	_tmp67_ = self->priv->app_notification;
#line 189 "../src/Window.vala"
	gtk_overlay_add_overlay (_tmp66_, (GtkWidget*) _tmp67_);
#line 191 "../src/Window.vala"
	_tmp68_ = overlay;
#line 191 "../src/Window.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp68_);
#line 192 "../src/Window.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 194 "../src/Window.vala"
	_tmp69_ = self->priv->navigation_button;
#line 194 "../src/Window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp69_);
#line 195 "../src/Window.vala"
	_tmp70_ = self->priv->search_entry;
#line 195 "../src/Window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp70_, FALSE);
#line 196 "../src/Window.vala"
	_tmp71_ = self->priv->autoqueue_next;
#line 196 "../src/Window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp71_, FALSE);
#line 198 "../src/Window.vala"
	_tmp72_ = manager;
#line 198 "../src/Window.vala"
	g_signal_connect_object (_tmp72_, "video-moved-to-trash", (GCallback) __audience_window___lambda96__audience_services_library_manager_video_moved_to_trash, self, 0);
#line 203 "../src/Window.vala"
	_tmp73_ = self->priv->deck;
#line 203 "../src/Window.vala"
	g_signal_connect_object ((GObject*) _tmp73_, "notify::visible-child", (GCallback) __audience_window___lambda97__g_object_notify, self, 0);
#line 207 "../src/Window.vala"
	_tmp74_ = self->priv->deck;
#line 207 "../src/Window.vala"
	g_signal_connect_object ((GObject*) _tmp74_, "notify::transition-running", (GCallback) __audience_window___lambda98__g_object_notify, self, 0);
#line 211 "../src/Window.vala"
	_tmp75_.target = "text/uri-list";
#line 211 "../src/Window.vala"
	_tmp75_.flags = (guint) 0;
#line 211 "../src/Window.vala"
	_tmp75_.info = (guint) 0;
#line 211 "../src/Window.vala"
	uris = _tmp75_;
#line 212 "../src/Window.vala"
	_tmp76_ = uris;
#line 212 "../src/Window.vala"
	_tmp77_ = g_new0 (GtkTargetEntry, 1);
#line 212 "../src/Window.vala"
	_tmp77_[0] = _tmp76_;
#line 212 "../src/Window.vala"
	_tmp78_ = _tmp77_;
#line 212 "../src/Window.vala"
	_tmp78__length1 = 1;
#line 212 "../src/Window.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp78_, (gint) 1, GDK_ACTION_MOVE);
#line 212 "../src/Window.vala"
	_tmp78_ = (g_free (_tmp78_), NULL);
#line 213 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) __audience_window___lambda99__gtk_widget_drag_data_received, self, 0);
#line 223 "../src/Window.vala"
	_tmp79_ = self->priv->_player_page;
#line 223 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp79_, "button-press-event", (GCallback) __audience_window___lambda100__gtk_widget_button_press_event, self, 0);
#line 238 "../src/Window.vala"
	_tmp80_ = self->priv->search_entry;
#line 238 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp80_, "key-press-event", (GCallback) __audience_window___lambda101__gtk_widget_key_press_event, self, 0);
#line 246 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) self, "window-state-event", (GCallback) __audience_window___lambda102__gtk_widget_window_state_event, self, 0);
#line 267 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) self, "configure-event", (GCallback) __audience_window___lambda103__gtk_widget_configure_event, self, 0);
#line 272 "../src/Window.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) __audience_window___lambda104__gtk_widget_motion_notify_event, self, 0);
#line 76 "../src/Window.vala"
	_g_object_unref0 (overlay);
#line 76 "../src/Window.vala"
	_g_object_unref0 (manager);
#line 76 "../src/Window.vala"
	_g_object_unref0 (application_instance);
#line 76 "../src/Window.vala"
	return obj;
#line 4233 "Window.c"
}

static void
audience_window_class_init (AudienceWindowClass * klass,
                            gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
	GeeMultiMap* _tmp3_;
	GeeMultiMap* _tmp4_;
	GeeMultiMap* _tmp5_;
	GeeMultiMap* _tmp6_;
	GeeMultiMap* _tmp7_;
	GeeMultiMap* _tmp8_;
#line 23 "../src/Window.vala"
	audience_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Window.vala"
	g_type_class_adjust_private_offset (klass, &AudienceWindow_private_offset);
#line 23 "../src/Window.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) audience_window_real_key_press_event;
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_audience_window_get_property;
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_audience_window_set_property;
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->constructor = audience_window_constructor;
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (klass)->finalize = audience_window_finalize;
#line 23 "../src/Window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY, audience_window_properties[AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY] = g_param_spec_object ("player-page", "player-page", "player-page", AUDIENCE_TYPE_PLAYER_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Window.vala"
	audience_window_signals[AUDIENCE_WINDOW_MEDIA_VOLUMES_CHANGED_SIGNAL] = g_signal_new ("media-volumes-changed", AUDIENCE_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 54 "../src/Window.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../src/Window.vala"
	audience_window_action_accelerators = (GeeMultiMap*) _tmp0_;
#line 66 "../src/Window.vala"
	_tmp1_ = audience_window_action_accelerators;
#line 66 "../src/Window.vala"
	gee_multi_map_set (_tmp1_, AUDIENCE_WINDOW_ACTION_BACK, "<Alt>Left");
#line 67 "../src/Window.vala"
	_tmp2_ = audience_window_action_accelerators;
#line 67 "../src/Window.vala"
	gee_multi_map_set (_tmp2_, AUDIENCE_WINDOW_ACTION_BACK, "Back");
#line 68 "../src/Window.vala"
	_tmp3_ = audience_window_action_accelerators;
#line 68 "../src/Window.vala"
	gee_multi_map_set (_tmp3_, AUDIENCE_WINDOW_ACTION_FULLSCREEN, "F");
#line 69 "../src/Window.vala"
	_tmp4_ = audience_window_action_accelerators;
#line 69 "../src/Window.vala"
	gee_multi_map_set (_tmp4_, AUDIENCE_WINDOW_ACTION_FULLSCREEN, "F11");
#line 70 "../src/Window.vala"
	_tmp5_ = audience_window_action_accelerators;
#line 70 "../src/Window.vala"
	gee_multi_map_set (_tmp5_, AUDIENCE_WINDOW_ACTION_OPEN_FILE, "<Control>O");
#line 71 "../src/Window.vala"
	_tmp6_ = audience_window_action_accelerators;
#line 71 "../src/Window.vala"
	gee_multi_map_set (_tmp6_, AUDIENCE_WINDOW_ACTION_QUIT, "<Control>Q");
#line 72 "../src/Window.vala"
	_tmp7_ = audience_window_action_accelerators;
#line 72 "../src/Window.vala"
	gee_multi_map_set (_tmp7_, AUDIENCE_WINDOW_ACTION_SEARCH, "<Control>F");
#line 73 "../src/Window.vala"
	_tmp8_ = audience_window_action_accelerators;
#line 73 "../src/Window.vala"
	gee_multi_map_set (_tmp8_, AUDIENCE_WINDOW_ACTION_UNDO, "<Control>Z");
#line 4303 "Window.c"
}

static void
audience_window_instance_init (AudienceWindow * self,
                               gpointer klass)
{
#line 23 "../src/Window.vala"
	self->priv = audience_window_get_instance_private (self);
#line 4312 "Window.c"
}

static void
audience_window_finalize (GObject * obj)
{
	AudienceWindow * self;
#line 23 "../src/Window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 24 "../src/Window.vala"
	_g_object_unref0 (self->priv->deck);
#line 25 "../src/Window.vala"
	_g_object_unref0 (self->priv->app_notification);
#line 26 "../src/Window.vala"
	_g_object_unref0 (self->priv->autoqueue_next);
#line 27 "../src/Window.vala"
	_g_object_unref0 (self->priv->episodes_page);
#line 28 "../src/Window.vala"
	_g_object_unref0 (self->priv->header);
#line 29 "../src/Window.vala"
	_g_object_unref0 (self->priv->library_page);
#line 30 "../src/Window.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 31 "../src/Window.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 32 "../src/Window.vala"
	_g_object_unref0 (self->priv->welcome_page);
#line 34 "../src/Window.vala"
	_g_object_unref0 (self->priv->_player_page);
#line 23 "../src/Window.vala"
	G_OBJECT_CLASS (audience_window_parent_class)->finalize (obj);
#line 4343 "Window.c"
}

static GType
audience_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AudienceWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceWindow), 0, (GInstanceInitFunc) audience_window_instance_init, NULL };
	GType audience_window_type_id;
	audience_window_type_id = g_type_register_static (gtk_application_window_get_type (), "AudienceWindow", &g_define_type_info, 0);
	AudienceWindow_private_offset = g_type_add_instance_private (audience_window_type_id, sizeof (AudienceWindowPrivate));
	return audience_window_type_id;
}

GType
audience_window_get_type (void)
{
	static volatile gsize audience_window_type_id__once = 0;
	if (g_once_init_enter (&audience_window_type_id__once)) {
		GType audience_window_type_id;
		audience_window_type_id = audience_window_get_type_once ();
		g_once_init_leave (&audience_window_type_id__once, audience_window_type_id);
	}
	return audience_window_type_id__once;
}

static void
_vala_audience_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	AudienceWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 23 "../src/Window.vala"
	switch (property_id) {
#line 23 "../src/Window.vala"
		case AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY:
#line 23 "../src/Window.vala"
		g_value_set_object (value, audience_window_get_player_page (self));
#line 23 "../src/Window.vala"
		break;
#line 4384 "Window.c"
		default:
#line 23 "../src/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Window.vala"
		break;
#line 4390 "Window.c"
	}
}

static void
_vala_audience_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	AudienceWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, AUDIENCE_TYPE_WINDOW, AudienceWindow);
#line 23 "../src/Window.vala"
	switch (property_id) {
#line 23 "../src/Window.vala"
		case AUDIENCE_WINDOW_PLAYER_PAGE_PROPERTY:
#line 23 "../src/Window.vala"
		audience_window_set_player_page (self, g_value_get_object (value));
#line 23 "../src/Window.vala"
		break;
#line 4410 "Window.c"
		default:
#line 23 "../src/Window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Window.vala"
		break;
#line 4416 "Window.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

